--
-- tugboat.GTD(0.7.1 -> 0.7.2) derby database
--


---  
--- Create TABLE
---

CREATE TABLE tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,VALUE                   varchar(64)   NOT NULL
);

CREATE TABLE task_tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,TAG_ID                  integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
   ,POSTED_AT               char(14)      NOT NULL
);

CREATE TABLE task_select_views (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,MODE_ID                 integer       NOT NULL default 0 
   ,CLASS_ID                integer       NOT NULL default 0
   ,IS_ViSIBLE_BROWSER      integer       NOT NULL default 0
   ,SELECTED_TAB_ID         integer       NOT NULL default 0
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_select_tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TAG_ID                  integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_statuses (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,STATUS_ID               integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_classifications (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,CLASS_ID                integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_activities (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,ACTIVITY_ID             integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_persons (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,PERSON_ID               integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE web_service_securities (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,CLIENT_ADDRESS          varchar(256)  NOT NULL
   ,NONCE                   char(20)      NOT NULL
   ,CREATED_AT              char(20)      NOT NULL
);

--
-- Add primary key.
--
ALTER TABLE tags
  ADD CONSTRAINT tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_tags
  ADD CONSTRAINT task_tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_select_views
  ADD CONSTRAINT task_select_views_pk
  PRIMARY KEY (ID);

ALTER TABLE task_select_tags
  ADD CONSTRAINT task_select_tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_statuses
  ADD CONSTRAINT task_browser_statuses_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_classifications
  ADD CONSTRAINT task_browser_classifications_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_activities
  ADD CONSTRAINT task_browser_activities_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_persons
  ADD CONSTRAINT task_browser_persons_pk
  PRIMARY KEY (ID);

ALTER TABLE web_service_securities
  ADD CONSTRAINT web_service_securities_pk
  PRIMARY KEY (ID);

--
-- Add Foreign key.
--
ALTER TABLE task_tags 
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks(ID);

ALTER TABLE task_tags 
  ADD FOREIGN KEY (TAG_ID) 
  REFERENCES tags(ID);
  
ALTER TABLE task_tags 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_select_views 
  ADD FOREIGN KEY (CLASS_ID) 
  REFERENCES classifications(ID);

ALTER TABLE task_select_views 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_select_tags 
  ADD FOREIGN KEY (TAG_ID) 
  REFERENCES tags(ID);
  
ALTER TABLE task_select_tags 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_statuses 
  ADD FOREIGN KEY (STATUS_ID) 
  REFERENCES task_statuses(ID);
  
ALTER TABLE task_browser_statuses 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_classifications 
  ADD FOREIGN KEY (CLASS_ID) 
  REFERENCES classifications(ID);
  
ALTER TABLE task_browser_classifications 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_activities 
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities(ID);

ALTER TABLE task_browser_activities 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_persons 
  ADD FOREIGN KEY (PERSON_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_persons 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

INSERT INTO classifications VALUES (0, 'T', 'Tasks');