--
-- tugboat.GTD(0.7.2 -> 0.7.3) derby database
--

UPDATE task_select_views SET selected_tab_id = 0;

-- add user roles.
CREATE TABLE user_roles (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,USER_ID                 integer       NOT NULL
   ,ROLE_ID                 integer       NOT NULL
);

ALTER TABLE user_roles
  ADD CONSTRAINT user_roles_pk
  PRIMARY KEY (ID);
  
ALTER TABLE user_roles 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);
  
ALTER TABLE user_roles 
  ADD FOREIGN KEY (ROLE_ID) 
  REFERENCES roles(ID);
  

INSERT INTO user_roles (
    USER_ID
   ,ROLE_ID
) SELECT id, 2 FROM users;

INSERT INTO users (
    ID
   ,LOGIN_ID
   ,PASSWORD
   ,EMAIL
   ,LAST_NAME
   ,MIDDLE_NAME
   ,FIRST_NAME
   ,PHOTO_IMG_URL
   ,DEL_FLAG
   ,REGISTERED
   ,MODIFIED
   ,MODIFIED_USER_ID
) SELECT 
    max(ID)+1
   ,'admin_user'
   ,'admin_user'
   ,'admin@mail.org'
   ,'admin'
   ,' '
   ,'Administrator'
   ,''
   ,'0'
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,max(ID)+1
FROM users;

INSERT INTO user_roles (
    USER_ID,
    ROLE_ID
) SELECT
    max(ID),
    1
FROM users;

-- add activity.
INSERT INTO activities (
    ID
   ,NAME
   ,DESCRIPTION
   ,START_DATE
   ,END_DATE
   ,DEL_FLAG
   ,REGISTERED
   ,MODIFIED
   ,MODIFIED_USER_ID
) SELECT
    max(A.ID)+1
   ,'Test Project'
   ,'Description'
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end 
   ,'99999999'
   ,'0'
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,max(U.ID)
FROM users U, activities A;

-- add activity member.
insert into activity_members (
    ACTIVITY_ID
   ,USER_ID 
   ,ROLE_ID
   ,START_DATE
   ,REGISTERED
   ,MODIFIED 
   ,MODIFIED_USER_ID
) SELECT
    max(A.ID)
   ,max(U.ID)
   ,1
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end 
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,RTRIM(CHAR(year(current_date))) ||
    CASE WHEN month(current_date) >9 then RTRIM(CHAR(month(current_date)))   else RTRIM('0'||CHAR(month(current_date)))  end ||
    CASE WHEN day(current_date)   >9 then RTRIM(CHAR(day(current_date)))     else RTRIM('0'||CHAR(day(current_date)))    end ||
    CASE WHEN hour(current_time)  >9 then RTRIM(CHAR(hour(current_time)))    else RTRIM('0'||CHAR(hour(current_time)))   end ||
    CASE WHEN minute(current_time)>9 then RTRIM(CHAR(minute(current_time)))  else RTRIM('0'||CHAR(minute(current_time))) end ||
    CASE WHEN second(current_time)>9 then RTRIM(CHAR(second(current_time)))  else RTRIM('0'||CHAR(second(current_time))) end 
   ,max(U.ID)
FROM users U, activities A;

-- add activity relation.
INSERT INTO activity_relations (
    ACTIVITY_ID
   ,COLOR_ID 
   ,USER_ID
) SELECT
    max(A.ID)
   ,1
   ,max(U.ID)
FROM users U, activities A;
