--
-- tugboat.GTD(0.7.3) derby database
--


---  
--- Create TABLE
---

CREATE TABLE activities (
    ID                       integer       NOT NULL
   ,NAME                     varchar(96)   NOT NULL   default 'Personal'
   ,ABBREVIATION             varchar(32)              default NULL
   ,DESCRIPTION              varchar(32672)
   ,STATUS                   char(1)       NOT NULL   default '0'
   ,START_DATE               char(8)                  default NULL
   ,END_DATE                 char(8)                  default NULL
   ,DEL_FLAG                 char(1)       NOT NULL   default '0'
   ,REGISTERED               char(14)      NOT NULL
   ,MODIFIED                 char(14)      NOT NULL
   ,MODIFIED_USER_ID         integer       NOT NULL
   ,IS_SEND_MAIL             char(1)       NOT NULL   default '0'
);

CREATE TABLE activity_colors (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,COLOR                    char(6)       NOT NULL
   ,NAME                     varchar(24)             default NULL
);

CREATE TABLE activity_members (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,ACTIVITY_ID              integer       NOT NULL
   ,USER_ID                  integer       NOT NULL
   ,ROLE_ID                  integer       NOT NULL   default 1
   ,START_DATE               char(8)                  default NULL
   ,END_DATE                 char(8)                  default NULL
   ,DEL_FLAG                 char(1)       NOT NULL   default '0'
   ,REGISTERED               char(14)      NOT NULL
   ,MODIFIED                 char(14)      NOT NULL
   ,MODIFIED_USER_ID         integer       NOT NULL
);

CREATE TABLE activity_relations (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,ACTIVITY_ID              integer       NOT NULL
   ,COLOR_ID                 integer       NOT NULL
   ,USER_ID                  integer       NOT NULL
   ,DISP_ORDER               integer       NOT NULL   default 1
);

CREATE TABLE alerts (
    ID                       integer       NOT NULL
   ,VALUE                    varchar(64)   NOT NULL
   ,VALUE_I18N               varchar(64)   NOT NULL   default ' '
);

CREATE TABLE classifications (
    ID                       integer       NOT NULL
   ,TYPE                     char(1)       NOT NULL
   ,VALUE                    varchar(64)   NOT NULL
);

CREATE TABLE roles (
    ID                       integer       NOT NULL
   ,TYPE                     char(1)       NOT NULL
   ,NAME                     varchar(96)   NOT NULL
   ,DESCRIPTION              varchar(256)  NOT NULL 
);

CREATE TABLE task_bodies (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                  integer       NOT NULL
   ,REV                      integer       NOT NULL   default 1
   ,BODY                     varchar(32672)          NOT NULL 
);

CREATE TABLE task_comment_bodies (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                  integer       NOT NULL
   ,COMMENT_ID               integer       NOT NULL
   ,REV                      integer       NOT NULL   default 1
   ,BODY                     varchar(32672)          NOT NULL 
);

CREATE TABLE task_comments (
    ID                       integer       NOT NULL
   ,TASK_ID                  integer       NOT NULL
   ,USER_ID                  integer       NOT NULL
   ,REGISTERED               char(14)      NOT NULL 
);

CREATE TABLE task_histories (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,STATUS_ID               integer       NOT NULL
   ,REGISTERED              char(14)      NOT NULL
   ,USER_ID                 integer       NOT NULL 
);

CREATE TABLE task_member_roles (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,ACTIVITY_MEMBER_ID      integer       NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,ROLE_ID                 integer       NOT NULL
);

CREATE TABLE task_relations (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,STATUS_ID               integer       NOT NULL
   ,ACTIVITY_ID             integer       NOT NULL
   ,CLASSIFICATION_ID       integer       NOT NULL
   ,ALERT_ID                integer       NOT NULL
   ,PERSON_ID               integer                  default NULL
   ,MANAGER_ID              integer                  default NULL
   ,POSTED_USER_ID          integer       NOT NULL
);

CREATE TABLE task_statuses (
    ID                       integer      NOT NULL
   ,VALUE                    varchar(64)  NOT NULL
   ,VALUE_I18N               varchar(64)  NOT NULL
);

CREATE TABLE task_to_tasks (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY       NOT NULL
   ,SRC_TASK_ID              integer      NOT NULL
   ,DEST_TASK_ID             integer      NOT NULL
);

CREATE TABLE tasks (
    ID                       integer      NOT NULL
   ,TITLE                    varchar(32672)         NOT NULL
   ,START_DATE               char(8)      NOT NULL
   ,START_YEAR               integer      NOT NULL
   ,START_MONTH              integer      NOT NULL
   ,START_DAY_OF_MONTH       integer      NOT NULL
   ,DEAD_LINE                char(8)                 default '99999999'
   ,DEAD_LINE_YEAR           integer                 default NULL
   ,DEAD_LINE_MONTH          integer                 default NULL
   ,DEAD_LINE_DAY_OF_MONTH   integer                 default NULL
   ,PRIORITY_ORDER           integer      NOT NULL
   ,DEL_FLAG                 char(1)      NOT NULL   default '0'
   ,REGISTERED               char(14)                default NULL
);

CREATE TABLE timezones (
    ID                       integer      NOT NULL
   ,TIMEZONE                 varchar(16)  NOT NULL
   ,OFFSET_TIME              integer      NOT NULL
   ,COUNTRY                  varchar(96)  NOT NULL
   ,COUNTRY_I18N             varchar(96)  NOT NULL
   ,DESCRIPTION              varchar(96)  NOT NULL
   ,DESCRIPTION_I18N         varchar(96)  NOT NULL
);

CREATE TABLE users (
    ID                       integer      NOT NULL
   ,LOGIN_ID                 varchar(64)  NOT NULL
   ,PASSWORD                 varchar(16)  NOT NULL
   ,EMAIL                    varchar(128) NOT NULL
   ,LAST_NAME                varchar(48)  NOT NULL
   ,MIDDLE_NAME              varchar(48)  NOT NULL   default ' '
   ,FIRST_NAME               varchar(48)  NOT NULL
   ,PHOTO_IMG_URL            varchar(128)            default NULL
   ,DEL_FLAG                 char(1)      NOT NULL   default '0'
   ,REGISTERED               char(14)     NOT NULL
   ,MODIFIED                 char(14)     NOT NULL
   ,MODIFIED_USER_ID         integer      NOT NULL
);

CREATE TABLE meeting_basics (
    ID                       integer      NOT NULL
   ,ACTIVITY_ID              integer      NOT NULL
   ,STATUS_ID                integer      NOT NULL   default 1
   ,TITLE                    varchar(32672)         NOT NULL
   ,START_DATE               char(8)      NOT NULL
   ,DEL_FLAG                 char(1)      NOT NULL   default '0'
   ,POSTED_USER_ID           integer      NOT NULL
   ,REGISTERED               char(14)     NOT NULL
   ,MODIFIED                 char(14)     NOT NULL
);

CREATE TABLE meeting_agendas (
    ID                       integer      NOT NULL
   ,PRIORITY                 char(1)      NOT NULL
   ,POSTED_USER_ID           integer      NOT NULL
   ,DEL_FLAG                 char(1)      NOT NULL   default '0'
   ,REGISTERED               char(14)     NOT NULL
   ,MODIFIED                 char(14)     NOT NULL
   ,MODIFIED_USER_ID         integer      NOT NULL
);

CREATE TABLE meeting_agenda_discussions (
    ID                       integer      NOT NULL
   ,AGENDA_ID                integer      NOT NULL
   ,TYPE                     char(1)      NOT NULL
   ,POSTED_USER_ID           integer      NOT NULL
   ,DEL_FLAG                 char(1)      NOT NULL   default '0'
   ,REGISTERED               char(14)     NOT NULL
   ,MODIFIED                 char(14)     NOT NULL
   ,MODIFIED_USER_ID         integer      NOT NULL
);

CREATE TABLE meeting_relations (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY       NOT NULL
   ,BASIC_ID                 integer      NOT NULL
   ,AGENDA_ID                integer      NOT NULL
);

CREATE TABLE meeting_to_tasks (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY       NOT NULL
   ,BASIC_ID                 integer      NOT NULL
   ,AGENDA_ID                integer      NOT NULL
   ,DISCUSSION_ID            integer      NOT NULL
   ,TASK_ID                  integer      NOT NULL
);

CREATE TABLE meeting_basic_bodies (
    ID                       integer GENERATED BY DEFAULT AS IDENTITY       NOT NULL
   ,BASIC_ID                 integer      NOT NULL
   ,REV                      integer      NOT NULL   default 1
   ,BODY                     varchar(32672)         NOT NULL
);

CREATE TABLE meeting_agenda_bodies (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,AGENDA_ID               integer       NOT NULL
   ,REV                     integer       NOT NULL   default 1
   ,BODY                    varchar(32672)          NOT NULL
);

CREATE TABLE meeting_agenda_discussion_bodies (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,AGENDA_ID               integer       NOT NULL
   ,DISCUSSION_ID           integer       NOT NULL
   ,REV                     integer       NOT NULL   default 1
   ,BODY                    varchar(32672)          NOT NULL
);

CREATE TABLE tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,VALUE                   varchar(64)   NOT NULL
);

CREATE TABLE task_tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,TAG_ID                  integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
   ,POSTED_AT               char(14)      NOT NULL
);

CREATE TABLE task_select_views (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,MODE_ID                 integer       NOT NULL default 0 
   ,CLASS_ID                integer       NOT NULL default 0
   ,IS_ViSIBLE_BROWSER      integer       NOT NULL default 0
   ,SELECTED_TAB_ID         integer       NOT NULL default 0
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_select_tags (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TAG_ID                  integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_statuses (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,STATUS_ID               integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_classifications (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,CLASS_ID                integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_activities (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,ACTIVITY_ID             integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE task_browser_persons (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,PERSON_ID               integer       NOT NULL
   ,USER_ID                 integer       NOT NULL
);

CREATE TABLE web_service_securities (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,CLIENT_ADDRESS          varchar(256)  NOT NULL
   ,NONCE                   char(20)      NOT NULL
   ,CREATED_AT              char(20)      NOT NULL
);

CREATE TABLE user_roles (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY NOT NULL
   ,USER_ID                 integer       NOT NULL
   ,ROLE_ID                 integer       NOT NULL
);

CREATE TABLE task_mails (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,MESSAGE_ID              varchar(256)  NOT NULL
   ,TASK_ID                 integer       NOT NULL
   ,SENT_AT                 char(14)      NOT NULL
   ,SENT_BY                 integer       NOT NULL
);

CREATE TABLE meeting_mails (
    ID                      integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,MESSAGE_ID              varchar(256)  NOT NULL
   ,BASIC_ID                integer       NOT NULL
   ,SENT_AT                 char(14)      NOT NULL
   ,SENT_BY                 integer       NOT NULL
);

CREATE TABLE feed_tokens (
    ID             integer GENERATED BY DEFAULT AS IDENTITY        NOT NULL
   ,TOKEN          char(20)      NOT NULL
   ,ACTIVITY_ID    integer       NOT NULL
   ,USER_ID        integer       NOT NULL
   ,DEL_FLAG       char(1)       NOT NULL
   ,CREATED_AT     char(14)      NOT NULL
);

--
-- Add primary key.
--
ALTER TABLE activities 
  ADD CONSTRAINT activities_pk 
  PRIMARY KEY (ID);

ALTER TABLE activity_colors 
  ADD CONSTRAINT activity_colors_pk 
  PRIMARY KEY (ID);

ALTER TABLE activity_members 
  ADD CONSTRAINT activity_members_pk 
  PRIMARY KEY (ID);

ALTER TABLE activity_relations
  ADD CONSTRAINT activity_relations_pk
  PRIMARY KEY (ID);

ALTER TABLE alerts 
  ADD CONSTRAINT alerts_pk
  PRIMARY KEY (ID);

ALTER TABLE classifications 
  ADD CONSTRAINT classifications_pk
  PRIMARY KEY (ID);

ALTER TABLE roles
  ADD CONSTRAINT roles_pk
  PRIMARY KEY (ID);

ALTER TABLE task_bodies 
  ADD CONSTRAINT task_bodies_pk
  PRIMARY KEY (ID);

ALTER TABLE task_comment_bodies
  ADD CONSTRAINT task_comment_bodies_pk
  PRIMARY KEY (ID);

ALTER TABLE task_comments
  ADD CONSTRAINT task_comments_pk 
  PRIMARY KEY (ID);

ALTER TABLE task_histories
  ADD CONSTRAINT task_histories_pk
  PRIMARY KEY (ID);

ALTER TABLE task_member_roles
  ADD CONSTRAINT task_member_roles_pk
  PRIMARY KEY (ID);

ALTER TABLE task_relations
  ADD CONSTRAINT task_relations_pk 
  PRIMARY KEY (ID);

ALTER TABLE task_statuses
  ADD CONSTRAINT task_statuses_pk 
  PRIMARY KEY (ID);

ALTER TABLE task_to_tasks
  ADD CONSTRAINT task_to_tasks_pk 
  PRIMARY KEY (ID);

ALTER TABLE tasks
  ADD CONSTRAINT tasks_pk 
  PRIMARY KEY (ID);

ALTER TABLE timezones
  ADD CONSTRAINT timezones_pk 
  PRIMARY KEY (ID);

ALTER TABLE users
  ADD CONSTRAINT users_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_basics
  ADD CONSTRAINT meeting_basics_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_agendas
  ADD CONSTRAINT meeting_agendas_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_agenda_discussions
  ADD CONSTRAINT meeting_agenda_discussions_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_relations
  ADD CONSTRAINT meeting_relations_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_to_tasks
  ADD CONSTRAINT meeting_to_tasks_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_basic_bodies
  ADD CONSTRAINT meeting_basic_bodies_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_agenda_bodies
  ADD CONSTRAINT meeting_agenda_bodies_pk 
  PRIMARY KEY (ID);

ALTER TABLE meeting_agenda_discussion_bodies
  ADD CONSTRAINT meeting_agenda_discussion_bodies_pk 
  PRIMARY KEY (ID);
  
ALTER TABLE tags
  ADD CONSTRAINT tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_tags
  ADD CONSTRAINT task_tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_select_views
  ADD CONSTRAINT task_select_views_pk
  PRIMARY KEY (ID);

ALTER TABLE task_select_tags
  ADD CONSTRAINT task_select_tags_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_statuses
  ADD CONSTRAINT task_browser_statuses_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_classifications
  ADD CONSTRAINT task_browser_classifications_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_activities
  ADD CONSTRAINT task_browser_activities_pk
  PRIMARY KEY (ID);

ALTER TABLE task_browser_persons
  ADD CONSTRAINT task_browser_persons_pk
  PRIMARY KEY (ID);

ALTER TABLE web_service_securities
  ADD CONSTRAINT web_service_securities_pk
  PRIMARY KEY (ID);

ALTER TABLE user_roles
  ADD CONSTRAINT user_roles_pk
  PRIMARY KEY (ID);
  
ALTER TABLE task_mails
  ADD CONSTRAINT task_mails_pk
  PRIMARY KEY (ID);

ALTER TABLE meeting_mails
  ADD CONSTRAINT meeting_mails_pk
  PRIMARY KEY (ID);

ALTER TABLE feed_tokens
  ADD CONSTRAINT feed_tokens_pk
  PRIMARY KEY (ID);

--
-- Add Foreign key.
--

ALTER TABLE activities 
  ADD FOREIGN KEY (MODIFIED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE activity_members
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities (ID);

ALTER TABLE activity_members
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users (ID);

ALTER TABLE activity_members
  ADD FOREIGN KEY (ROLE_ID) 
  REFERENCES roles (ID);

ALTER TABLE activity_members
  ADD FOREIGN KEY (MODIFIED_USER_ID) 
  REFERENCES users (ID);

ALTER TABLE activity_relations
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities (ID);

ALTER TABLE activity_relations
  ADD FOREIGN KEY (COLOR_ID) 
  REFERENCES activity_colors (ID);

ALTER TABLE activity_relations
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_bodies
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_comment_bodies
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_comment_bodies
  ADD FOREIGN KEY (COMMENT_ID) 
  REFERENCES task_comments (ID);

ALTER TABLE task_comments
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_comments
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_histories
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_histories
  ADD FOREIGN KEY (STATUS_ID) 
  REFERENCES task_statuses (ID);

ALTER TABLE task_histories
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_member_roles
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_member_roles
  ADD FOREIGN KEY (ROLE_ID) 
  REFERENCES roles (ID);

ALTER TABLE task_member_roles
  ADD FOREIGN KEY (ACTIVITY_MEMBER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (STATUS_ID) 
  REFERENCES task_statuses (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (CLASSIFICATION_ID) 
  REFERENCES classifications (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (ALERT_ID) 
  REFERENCES alerts (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (PERSON_ID) 
  REFERENCES users (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (MANAGER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_relations
  ADD FOREIGN KEY (POSTED_USER_ID) 
  REFERENCES users (ID);

ALTER TABLE task_to_tasks
  ADD FOREIGN KEY (SRC_TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE task_to_tasks
  ADD FOREIGN KEY (DEST_TASK_ID) 
  REFERENCES tasks (ID);

ALTER TABLE meeting_basics
  ADD FOREIGN KEY (POSTED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE meeting_basics
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities(ID);

ALTER TABLE meeting_agendas
  ADD FOREIGN KEY (POSTED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE meeting_agendas
  ADD FOREIGN KEY (MODIFIED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE meeting_agenda_discussions
  ADD FOREIGN KEY (AGENDA_ID) 
  REFERENCES meeting_agendas(ID);

ALTER TABLE meeting_agenda_discussions
  ADD FOREIGN KEY (POSTED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE meeting_agenda_discussions
  ADD FOREIGN KEY (MODIFIED_USER_ID) 
  REFERENCES users(ID);

ALTER TABLE meeting_relations
  ADD FOREIGN KEY(BASIC_ID) 
  REFERENCES meeting_basics(ID);

ALTER TABLE meeting_relations
  ADD FOREIGN KEY(AGENDA_ID) 
  REFERENCES meeting_agendas(ID);

ALTER TABLE meeting_to_tasks
  ADD FOREIGN KEY(BASIC_ID) 
  REFERENCES meeting_basics(ID);

ALTER TABLE meeting_to_tasks
  ADD FOREIGN KEY(AGENDA_ID) 
  REFERENCES meeting_agendas(ID);

ALTER TABLE meeting_to_tasks
  ADD FOREIGN KEY(DISCUSSION_ID) 
  REFERENCES meeting_agenda_discussions(ID);

ALTER TABLE meeting_to_tasks
  ADD FOREIGN KEY(TASK_ID) 
  REFERENCES tasks(ID);

ALTER TABLE meeting_basic_bodies
  ADD FOREIGN KEY (BASIC_ID) 
  REFERENCES meeting_basics (ID);

ALTER TABLE meeting_agenda_bodies
  ADD FOREIGN KEY (AGENDA_ID) 
  REFERENCES meeting_agendas (ID);

ALTER TABLE meeting_agenda_discussion_bodies
  ADD FOREIGN KEY (AGENDA_ID)     
  REFERENCES meeting_agendas (ID);

ALTER TABLE meeting_agenda_discussion_bodies
  ADD FOREIGN KEY (DISCUSSION_ID) 
  REFERENCES meeting_agenda_discussions (ID);

ALTER TABLE task_tags 
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks(ID);

ALTER TABLE task_tags 
  ADD FOREIGN KEY (TAG_ID) 
  REFERENCES tags(ID);
  
ALTER TABLE task_tags 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_select_views 
  ADD FOREIGN KEY (CLASS_ID) 
  REFERENCES classifications(ID);

ALTER TABLE task_select_views 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_select_tags 
  ADD FOREIGN KEY (TAG_ID) 
  REFERENCES tags(ID);
  
ALTER TABLE task_select_tags 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_statuses 
  ADD FOREIGN KEY (STATUS_ID) 
  REFERENCES task_statuses(ID);
  
ALTER TABLE task_browser_statuses 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_classifications 
  ADD FOREIGN KEY (CLASS_ID) 
  REFERENCES classifications(ID);
  
ALTER TABLE task_browser_classifications 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_activities 
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities(ID);

ALTER TABLE task_browser_activities 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_persons 
  ADD FOREIGN KEY (PERSON_ID) 
  REFERENCES users(ID);

ALTER TABLE task_browser_persons 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);

ALTER TABLE user_roles 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);
  
ALTER TABLE user_roles 
  ADD FOREIGN KEY (ROLE_ID) 
  REFERENCES roles(ID);

ALTER TABLE task_mails 
  ADD FOREIGN KEY (TASK_ID) 
  REFERENCES tasks(ID);

ALTER TABLE task_mails 
  ADD FOREIGN KEY (SENT_BY) 
  REFERENCES users(ID);
  
ALTER TABLE meeting_mails 
  ADD FOREIGN KEY (BASIC_ID) 
  REFERENCES meeting_basics(ID);
  
ALTER TABLE meeting_mails 
  ADD FOREIGN KEY (SENT_BY) 
  REFERENCES users(ID);
  
ALTER TABLE feed_tokens 
  ADD FOREIGN KEY (ACTIVITY_ID) 
  REFERENCES activities(ID);
  
ALTER TABLE feed_tokens 
  ADD FOREIGN KEY (USER_ID) 
  REFERENCES users(ID);
  