/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Search result info dto.
 * 
 * @author yousuke.hara
 * 
 */
public class SearchResultInfoDto implements Serializable {
    static final long serialVersionUID = 1L;

    /* search processing time */
    float processingTime_;

    public float getProcessingTime() {
        return processingTime_;
    }

    public void setProcessingTime(float processingTime) {
        this.processingTime_ = processingTime;
    }

    /* count */
    long count_;

    public long getCount() {
        return count_;
    }

    public void setCount(long count) {
        this.count_ = count;
    }

    /* keyword */
    String keyword_;

    public String getKeyword() {
        return this.keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* search result */
    SearchDto[] searchResultDtos_;

    public SearchDto[] getSearchResultDtos() {
        return searchResultDtos_;
    }

    public void setSearchResultDtos(SearchDto[] searchResultDtos) {
        this.searchResultDtos_ = searchResultDtos;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
