/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Page Control Annotation.
 * 
 * @author yousuke.hara
 */
public class SecurityDto implements Serializable {
    static final long serialVersionUID = 1L;

    public SecurityDto() {
        super();
    }

    /* form id */
    String formId_;

    public String getFormId() {
        return formId_;
    }

    public void setFormId(String formId) {
        this.formId_ = formId;
    }

    /* description */
    String description_;

    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* is authorization check */
    boolean isAuthorizationCheck_;

    public boolean isAuthorizationCheck() {
        return isAuthorizationCheck_;
    }

    public void setAuthorizationCheck(boolean isAuthorizationCheck) {
        this.isAuthorizationCheck_ = isAuthorizationCheck;
    }

    /* is direct access check */
    boolean isDirectAccessCheck_;

    public boolean isDirectAccessCheck() {
        return isDirectAccessCheck_;
    }

    public void setDirectAccessCheck(boolean isDirectAccessCheck) {
        this.isDirectAccessCheck_ = isDirectAccessCheck;
    }

    /* error page */
    String errorPage_;

    public String getErrorPage() {
        return errorPage_;
    }

    public void setErrorPage(String errorPage) {
        this.errorPage_ = errorPage;
    }
    
    /* is admin tool */
    boolean isAdminTool_ = false;
    
    public boolean getIsAdminTool() {
        return isAdminTool_;
    }
    
    public void setIsAdminTool(boolean isAdminTool) {
        this.isAdminTool_ = isAdminTool;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
