/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.sao;

import org.seasar.tugboat.gtd.container.dto.SearchDto;
import org.seasar.tugboat.search.SearchCondition;

/**
 * Search SAO
 * 
 * @author Yoshio Shinozaki
 */
public interface SearchSao {

    /**
     * Store SearchDto
     * 
     * @param dto
     */
    int save(SearchDto dto);

    /**
     * Store SearchDto's
     * 
     * @param dto
     */
    int saves(SearchDto[] dto);

    /**
     * Find SearchDto
     * 
     * @param dto
     */
    SearchDto[] find(SearchCondition condition);
}
