/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.container.service;

import org.seasar.tugboat.gtd.container.dto.SearchConditionDto;
import org.seasar.tugboat.gtd.container.dto.SearchDto;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgenda;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgendaDiscussion;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingBasic;
import org.seasar.tugboat.gtd.contents.task.entity.TaskCommentRelation;
import org.seasar.tugboat.gtd.contents.task.entity.TaskRelation;

/**
 * Search Service.
 * 
 * @author yousuke.hara
 * 
 */
public interface SearchService {
    public static final String ID_SEPARATOR = "/";
    public static final int CLASS_TASK = 10;
    public static final int CLASS_TASK_COMMENT = 15;
    public static final int CLASS_MEETING = 20;
    public static final int CLASS_MEETING_AGENDA = 23;
    public static final int CLASS_MEETING_COMMENT = 26;
    public static final int CLASS_ACTIVETY = 30;

    /**
     * generate task index.
     * 
     * @param entity
     * @return
     */
    int generateTaskIndex(TaskRelation entity);

    /**
     * generate task comment index.
     * 
     * @param entity
     * @return
     */
    int generateTaskCommentIndex(TaskCommentRelation entity);

    /**
     * generate meeting index.
     * 
     * @param entity
     * @return
     */
    int generateMeetingIndex(MeetingBasic entity);

    /**
     * generate meeting agenda index.
     * 
     * @param entity
     * @return
     */
    int generateMeetingAgendaIndex(MeetingAgenda entity);

    /**
     * generate meeting agenda discussion index.
     * 
     * @param entity
     * @return
     */
    int generateMeetingAgendaDiscussionIndex(MeetingAgendaDiscussion entity);

    /**
     * search.
     * 
     * @param searchCondition
     * @param userId
     * @return
     */
    SearchDto[] search(SearchConditionDto searchConditionDto, int userId);
}
