/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.dto;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.activity.entity.Activity;

/**
 * Activity DTO
 * 
 * @author yousuke.hara
 * 
 */
public class ActivityDto extends Activity {
    static final long serialVersionUID = 1L;
    List<ActivityMemberDto> memberList_ = new ArrayList<ActivityMemberDto>();
    
    public ActivityDto() {
        super();
    }

    /**
     * add member
     * 
     * @param member
     */
    public synchronized void addMember(ActivityMemberDto member) {
        memberList_.add(member);
    }
    
    /**
     * get member list.
     * 
     * @return
     */
    public synchronized List<ActivityMemberDto> getMembers() {
        return memberList_;
    }

    /* member user id */
    int[] memberUserId_;

    public int[] getMemberUserId() {
        return memberUserId_;
    }

    public void setMemberUserId(int[] memberUserId) {
        this.memberUserId_ = memberUserId;
    }

    /* member role id */
    int[] memberRoleId_;

    public int[] getMemberRoleId() {
        return memberRoleId_;
    }

    public void setMemberRoleId(int[] memberRoleId) {
        this.memberRoleId_ = memberRoleId;
    }

    /* keyword */
    String keyword_;

    public String getKeyword() {
        return keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* registered formated string */
    String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
