/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Activity.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "activities")
public class Activity implements Serializable {

    static final long serialVersionUID = 1L;

    public Activity() {
        super();
    }

    /* Id */
    protected int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* Index */
    protected String index_ = "";

    public String getIndex() {
        return index_;
    }

    public void setIndex(String index) {
        this.index_ = index;
    }

    /* Name */
    protected String name_ = "";

    @Column("NAME")
    public String getName() {
        return name_;
    }

    public void setName(String name) {
        this.name_ = name;
    }

    /* Abbreviation */
    protected String abbreviation_ = "";

    @Column("ABBREVIATION")
    public String getAbbreviation() {
        return abbreviation_;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation_ = abbreviation;
    }

    /* Start Date */
    protected String startDate_ = "";

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* End Date */
    protected String endDate_ = "";

    @Column("END_DATE")
    public String getEndDate() {
        return endDate_;
    }

    public void setEndDate(String endDate) {
        this.endDate_ = endDate;
    }

    /* Status Id */
    protected int statusId_;

    @Column("STATUS")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* Status Label */
    protected String statusLabel_ = "";

    public String getStatusLabel() {
        return statusLabel_;
    }

    public void setStatusLabel(String statusLabel) {
        this.statusLabel_ = statusLabel;
    }

    /* description */
    protected String description_ = "";

    @Column("DESCRIPTION")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* modified datetime */
    protected String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* modified user id */
    protected int modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public int getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(int modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* class id */
    protected int classId_;

    @Column("CLASS_ID")
    public int getClassId() {
        return classId_;
    }

    public void setClassId(int classId) {
        this.classId_ = classId;
    }

    /* class name */
    protected String className_;

    @Column("CLASS_NAME")
    public String getClassName() {
        return className_;
    }

    public void setClassName(String className) {
        this.className_ = className;
    }

    /* color id */
    int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color */
    String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }
    
    /* color name */
    String colorName_;
    
    @Column("COLOR_NAME")
    public String getColorName() {
        return colorName_;
    }
    
    public void setColorName(String colorName) {
        this.colorName_ = colorName;
    }
    
    /* is send mail flag ("0" is not send, "1" is send)*/
    String isSendMail_ = "0";
    
    @Column("IS_SEND_MAIL")
    public String getIsSendMail() {
        return isSendMail_;
    }
    public void setIsSendMail(String isSendMail) {
        this.isSendMail_ = isSendMail;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
