/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * activity members
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "activity_members")
public class ActivityMember implements Serializable {
    static final long serialVersionUID = 1L;

    public static final String DELETE = "1";

    public static final String NOT_DELETED = "0";

    /* calendar livemeeting topic id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* activity id */
    int activityId_;

    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }

    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }

    /* user id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* role id */
    int roleId_;

    @Column("ROLE_ID")
    public int getRoleId() {
        return roleId_;
    }

    public void setRoleId(int roleId) {
        this.roleId_ = roleId;
    }

    /* role name */
    String roleName_;

    @Column("ROLE_NAME")
    public String getRoleName() {
        return roleName_;
    }

    public void setRoleName(String roleName) {
        this.roleName_ = roleName;
    }

    /* start date */
    String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* end date */
    String endDate_;

    @Column("END_DATE")
    public String getEndDate() {
        return endDate_;
    }

    public void setEndDate(String endDate) {
        this.endDate_ = endDate;
    }

    /* delete */
    String deleteFlag_;

    @Column("DEL_FALG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* calendar livemeeting topic modified */
    String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    int modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public int getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(int modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* m_user id */
    String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* m_user last name */
    String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* m_user middle name */
    String middleName_;

    @Column("MIDDLE_NAME")
    public String getMiddleName() {
        return middleName_;
    }

    public void setMiddleName(String middleName) {
        this.middleName_ = middleName;
    }

    /* m_user photo img url */
    String photoImgUrl_;

    @Column("PHOTO_IMG_URL")
    public String getPhotoImgUrl() {
        return photoImgUrl_;
    }

    public void setPhotoImgUrl(String photoImgUrl) {
        this.photoImgUrl_ = photoImgUrl;
    }
    
    /* email */
    String email_;
    
    @Column("EMAIL")
    public String getEmail() {
        return email_;
    }
    
    public void setEmail(String email) {
        this.email_ = email;
    }
    
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
