/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.helper;

import org.seasar.tugboat.gtd.contents.activity.dto.ActivityDto;
import org.seasar.tugboat.gtd.contents.activity.dto.ActivityMemberDto;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;

/**
 * activity helper.
 * 
 * @author yousuke.hara
 * 
 */
public interface ActivityHelper {

    /**
     * create own activities json.
     * 
     * @param activities
     * @return
     */
    String createOwnActivitiesJSON(ActivityDto[] activities);

    /**
     * create own activities for select menu json.
     * 
     * @param activities
     * @return
     */
    String createOwnActivitiesForSelectMenuJSON(ActivityDto[] activities);

    /**
     * create members json.
     * 
     * @param members
     * @param totalRecords
     * @param currentPageNumber
     * @param recordPerPage
     * @return
     */
    String createMembersJSON(
        ActivityMemberDto[] members, int totalRecords, int currentPageNumber, int recordPerPage, int userId);

    /**
     * create member json.
     * 
     * @param member
     * @return
     */
    String createMemberJson(ActivityMemberDto member);

    /**
     * create users for auto completer JSON.
     * 
     * @param users
     * @return
     */
    String createUsersForAutoCompleterHTML(UserDto[] users);

    /**
     * create person in charge JSON.
     * 
     * @param meId
     * @param members
     * @return
     */
    public String createPersonInChargeJSON(int meId, ActivityMemberDto[] members);
}
