/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.activity.page;

/**
 * activity member ajax.
 * 
 * @author yosuke
 * 
 */
public interface ActivityMemberAjax {

    /**
     * add activity member.
     * 
     * @return
     */
    String add();

    /**
     * update activity member.
     * 
     * @return
     */
    String update();

    /**
     * get activity members.
     * 
     * @return
     */
    String getActivityMembers();
    
    /**
     * get activity members by activities.
     * @return
     */
    String getActivityMembersByActivities();

    /**
     * get activity members by activity id and keyword.
     * 
     * @return
     */
    String getActivityMembersByActivityIdAndKeyword();

    /**
     * check already exists.
     * 
     * @return
     */
    String checkAlreadyExists();

    /**
     * get activity members json.
     * 
     * @return
     */
    String getActivityMembersJSON();
    
    /**
     * remove activity member.
     * @return
     */
    String remove();
}
