/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.dxo.impl;

import org.apache.commons.beanutils.BeanUtils;
import org.seasar.tugboat.gtd.container.exception.SystemUnexpectedRuntimeException;
import org.seasar.tugboat.gtd.contents.common.dto.PreferenceDto;
import org.seasar.tugboat.gtd.contents.common.dxo.CommonDxo;
import org.seasar.tugboat.gtd.contents.common.entity.Preference;

/**
 * common dxo impl.
 * 
 * @author yosuke
 * 
 */
public class CommonDxoImpl implements CommonDxo {
    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.common.dxo.CommonDxo#convertCalendarPreferenceDto(org.seasar.tugboat.gtd.contents.common.entity.Preference)
     */
    public PreferenceDto convertCalendarPreferenceDto(Preference preference) {
        try {
            PreferenceDto dto = new PreferenceDto();
            BeanUtils.copyProperties(dto, preference);
            return dto;
        } catch (Exception e) {
            throw new SystemUnexpectedRuntimeException(e);
        }
    }
}
