/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Calendar classification.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "classifications")
public class Classification implements Serializable {
    static final long serialVersionUID = 1L;
    
    /** tasks */
    public static int TASKS = 0;
    
    /** class inbox. */
    public static int INBOX = 9;
    /** class today. */
    public static int TODAY = 1;
    /** class week */
    public static int WEEK = 2;
    /** class month */
    public static int MONTH = 3;
    /** class hold */
    public static int HOLD = 4;
    /** class someday */
    public static int SOMEDAY = 5;
    /** calss archives */
    public static int ARCHIVES = 21;
    /** calss trash */
    public static int TRASH = 99;
    
    public Classification() {}
    public Classification(int id, String value, int numberOfCount) {
        this.id_ = id;
        this.value_ = value;
        this.numberOfCount_ = numberOfCount;
    }
    
    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* type */
    String type_;

    @Column("TYPE")
    public String getType() {
        return type_;
    }

    public void setType(String type) {
        this.type_ = type;
    }

    /* value */
    String value_;

    @Column("VALUE")
    public String getValue() {
        return value_;
    }

    public void setValue(String value) {
        this.value_ = value;
    }

    /* number of count */
    int numberOfCount_;
    
    public int getNumberOfCount() {
        return numberOfCount_;
    }
    
    public void setNumberOfCount(int numberOfCount) {
        this.numberOfCount_ = numberOfCount;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
