/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.entity;

import java.io.Serializable;
import java.util.Calendar;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Calendar preference.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "calendar_preference_relations")
public class Preference implements Serializable {
    static final long serialVersionUID = 1L;

    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* time zone */
    String timeZone_;

    @Column("TIMEZONE")
    public String getTimeZone() {
        return timeZone_;
    }

    public void setTimeZone(String timeZone) {
        this.timeZone_ = timeZone;
    }

    /* date format */
    String dateFormat_;

    @Column("DATE_FORMAT")
    public String getDateFormat() {
        return dateFormat_;
    }

    public void setDateFormat(String dateFormat) {
        this.dateFormat_ = dateFormat;
    }

    /* time format */
    String timeFormat_;

    @Column("TIME_FORMAT")
    public String getTimeFormat() {
        return timeFormat_;
    }

    public void setTimeFormat(String timeFormat) {
        this.timeFormat_ = timeFormat;
    }

    /* user id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* first day of week */
    int firstDayOfWeek_ = Calendar.SUNDAY;

    @Column("FIRST_DAY_OF_WEEK")
    public int getFirstDayOfWeek() {
        return firstDayOfWeek_;
    }

    public void setFirstDayOfWeek(int firstDayOfWeek) {
        this.firstDayOfWeek_ = firstDayOfWeek;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
