/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.common.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Role. 
 *
 */
@Bean(table = "roles")
public class Role implements Serializable {
    static final long serialVersionUID = 1L;

    public Role() {
        super();
    }

    /* id */
    int id_;
    
    @Column("id")
    public int getId() {
        return id_;
    }
    public void setId(int id) {
        this.id_ = id;
    }
    
    /* name */
    String name_;

    @Column("name")
    public String getName() {
        return name_;
    }
    public void setName(String name) {
        this.name_ = name;
    }
    
    /* description */
    String description_;
    
    @Column("description")
    public String getDescription() {
        return description_;
    }
    public void setDescription(String description) {
        this.description_ = description;
    }

    /*
     * (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
