/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.login.service.impl;

import org.seasar.tugboat.gtd.container.entity.WebServiceSecurity;
import org.seasar.tugboat.gtd.contents.login.dao.WebServiceSecuritiesDao;
import org.seasar.tugboat.gtd.contents.login.service.WebServiceAuthService;

/**
 * Web Service Authorize Service implement.
 *  
 * @author yousuke
 *
 */
public class WebServiceAuthServiceImpl implements WebServiceAuthService {

	/* web service securities dao */
	WebServiceSecuritiesDao webServiceSecuritiesDao_;
	public void setWebServiceSecuritiesDao(WebServiceSecuritiesDao webServiceSecuritiesDao) {
		this.webServiceSecuritiesDao_ = webServiceSecuritiesDao;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.seasar.tugboat.gtd.contents.login.service.WebServiceAuthService#add(
	 *   org.seasar.tugboat.gtd.container.entity.WebServiceSecurity)
	 */
	public void add(WebServiceSecurity webServiceSecurity) {
		this.webServiceSecuritiesDao_.insert(webServiceSecurity);
	}

	/*
	 * (non-Javadoc)
	 * @see org.seasar.tugboat.gtd.contents.login.service.WebServiceAuthService#findByNonceAndCreated(
	 *   java.lang.String, java.lang.String)
	 */
	public WebServiceSecurity findByNonceAndCreated(String nonce, String created) {
		return this.webServiceSecuritiesDao_.findByNonceAndCreated(nonce, created);
	}

}
