/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingBasic;

/**
 * meeting basic dto
 * 
 * 
 */
public class MeetingBasicDto extends MeetingBasic implements Serializable{
    static final long serialVersionUID = 1L;

    /* body converted textile */
    String bodyConvertedTextile_;

    public String getBodyConvertedTextile() {
        return bodyConvertedTextile_;
    }

    public void setBodyConvertedTextile(String bodyConvertedTextile) {
        this.bodyConvertedTextile_ = bodyConvertedTextile;
    }

    /* user id. */
    int userId_;

    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* query status ids. */
    Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query activity ids. */
    Integer[] queryActivityIds_;

    public Integer[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(Integer[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query register ids. */
    Integer[] queryRegisterIds_;

    public Integer[] getQueryRegisterIds() {
        return queryRegisterIds_;
    }

    public void setQueryRegisterIds(Integer[] queryRegisterIds) {
        this.queryRegisterIds_ = queryRegisterIds;
    }

    /* meeting links. */
    MeetingRelatedTaskDto[] meetingLinks_;

    public MeetingRelatedTaskDto[] getMeetingLinks() {
        return meetingLinks_;
    }

    public void setMeetingLinks(MeetingRelatedTaskDto[] meetingLinks) {
        this.meetingLinks_ = meetingLinks;
    }

    /* offset */
    int offset_;

    public int getOffset() {
        return offset_;
    }

    public void setOffset(int offset) {
        this.offset_ = offset;
    }

    /* limit */
    int limit_;

    public int getLimit() {
        return limit_;
    }

    public void setLimit(int limit) {
        this.limit_ = limit;
    }
    
    /* Registered formated */
    String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.calendar.entity.CalendarEvent#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
