/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting agenda discussion.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_agenda_discussions")
public class MeetingAgendaDiscussion implements Serializable {
    static final long serialVersionUID = 1L;
    public static final int TYPE_COMMENT = 1;
    public static final int TYPE_CONCLUSION = 2;
    public static final int TYPE_MEMO = 3;
    public static final int TYPE_ATTACHMENT = 4;
    public static final int TYPE_TODO = 5;

    /* meeting agenda discussion id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* basic id */
    int meetingBasicId_;

    @Column("BASIC_ID")
    public int getMeetingBasicId() {
        return meetingBasicId_;
    }

    public void setMeetingBasicId(int meetingBasicId) {
        this.meetingBasicId_ = meetingBasicId;
    }

    /* meeting agenda discussion agenda id */
    int agendaId_;

    @Column("AGENDA_ID")
    public int getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(int agendaId) {
        this.agendaId_ = agendaId;
    }

    /* meeting agenda discussion type */
    String type_;

    @Column("TYPE")
    public String getType() {
        return type_;
    }

    public void setType(String type) {
        this.type_ = type;
    }

    /* meeting agenda discussion posted User Id */
    int postedUserId_;

    @Column("POSTED_USER_ID")
    public int getPostedUserId() {
        return postedUserId_;
    }

    public void setPostedUserId(int postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* meeting basic deleteFlag */
    String deleteFlag_;

    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* meeting agenda discussion registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* meeting agenda discussion modified */
    String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }

    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /* meeting agenda discussion modified user id */
    int modifiedUserId_;

    @Column("MODIFIED_USER_ID")
    public int getModifiedUserId() {
        return modifiedUserId_;
    }

    public void setModifiedUserId(int modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* meeting agenda discussion body */
    String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    /* user id */
    String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* user last name */
    String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* activity id */
    int activityId_;

    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }

    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }

    /* color value */
    String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /* task id */
    int taskId_;
    
    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }
    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }
    
    /* task title */
    String taskTitle_;

    @Column("TASK_TITLE")
    public String getTaskTitle() {
        return taskTitle_;
    }

    public void setTaskTitle(String taskTitle) {
        this.taskTitle_ = taskTitle;
    }

    /* task description */
    String taskDescription_;

    @Column("TASK_DESCRIPTION")
    public String getTaskDescription() {
        return taskDescription_;
    }

    public void setTaskDescription(String taskDescription) {
        this.taskDescription_ = taskDescription;
    }

    /* task dead line */
    String taskDeadLine_;

    @Column("TASK_DEAD_LINE")
    public String getTaskDeadLine() {
        return taskDeadLine_;
    }

    public void setTaskDeadLine(String taskDeadLine) {
        this.taskDeadLine_ = taskDeadLine;
    }

    /* task person id */
    int taskPersonId_;

    @Column("TASK_PERSON_ID")
    public int getTaskPersonId() {
        return taskPersonId_;
    }

    public void setTaskPersonId(int taskPersonId) {
        this.taskPersonId_ = taskPersonId;
    }

    /* task person first name */
    String taskPersonFirstName_;

    @Column("TASK_PERSON_FIRST_NAME")
    public String getTaskPersonFirstName() {
        return taskPersonFirstName_;
    }

    public void setTaskPersonFirstName(String taskPersonFirstName) {
        this.taskPersonFirstName_ = taskPersonFirstName;
    }

    /* task person last name */
    String taskPersonLastName_;

    @Column("TASK_PERSON_LAST_NAME")
    public String getTaskPersonLastName() {
        return taskPersonLastName_;
    }

    public void setTaskPersonLastName(String taskPersonLastName) {
        this.taskPersonLastName_ = taskPersonLastName;
    }

    /* task status id */
    int taskStatusId_;

    @Column("TASK_STATUS_ID")
    public int getTaskStatusId() {
        return taskStatusId_;
    }

    public void setTaskStatusId(int taskStatusId) {
        this.taskStatusId_ = taskStatusId;
    }

    /* task classification id */
    int taskClassificationId_;

    @Column("TASK_CLASSIFICATION_ID")
    public int getTaskClassificationId() {
        return taskClassificationId_;
    }

    public void setTaskClassificationId(int taskClassificationId) {
        this.taskClassificationId_ = taskClassificationId;
    }    
    
    /* task classification value */
    String taskClassificationValue_;
    
    @Column("TASK_CLASSIFICATION_VALUE")
    public String getTaskClassificationValue() {
        return taskClassificationValue_;
    }
    
    public void setTaskClassificationValue(String taskClassificationValue) {
        this.taskClassificationValue_ = taskClassificationValue;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
