/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting agenda discussion body
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_agenda_discussion_bodies")
public class MeetingAgendaDiscussionBody {
    static final long serialVersionUID = 1L;

    /* meeting agenda discussion body id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* meeting agenda discussion body agenda id */
    int agendaId_;

    @Column("AGENDA_ID")
    public int getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(int agendaId) {
        this.agendaId_ = agendaId;
    }

    /* meeting agenda discussion body discussion id */
    int discussionId_;

    @Column("DISCUSSION_ID")
    public int getDiscussionId() {
        return discussionId_;
    }

    public void setDiscussionId(int discussionId) {
        this.discussionId_ = discussionId;
    }

    /* meeting agenda discussion body rev */
    int rev_;

    @Column("REV")
    public int getRev() {
        return rev_;
    }

    public void setRev(int rev) {
        this.rev_ = rev;
    }

    /* meeting agenda discussion body body */
    String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }

    public void setBody(String body) {
        this.body_ = body;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
