/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting basic.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_basics")
public class MeetingBasic {
    static final long serialVersionUID = 1L;

    public static final int STATUS_NEW = 1;
    public static final int STATUS_OPEN = 2;
    public static final int STATIS_CLOSE = 3;

    /* row count */
    int rowCount_;

    @Column("ROW_COUNT")
    public int getRowCount() {
        return rowCount_;
    }
    public void setRowCount(int rowCount) {
        this.rowCount_ = rowCount;
    }

    /* library count */
    int libraryCount_;

    @Column("LIBRARY_COUNT")
    public int getLibraryCount() {
        return libraryCount_;
    }
    public void setLibraryCount(int libraryCount) {
        this.libraryCount_ = libraryCount;
    }

    /* archives count */
    int archivesCount_;

    @Column("ARCHIVES_COUNT")
    public int getArchivesCount() {
        return archivesCount_;
    }
    public void setArchivesCount(int archivesCount) {
        this.archivesCount_ = archivesCount;
    }

    /* meeting basic id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }
    public void setId(int id) {
        this.id_ = id;
    }

    /* meeting basic activity id */
    int activityId_;

    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }
    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }
    
    /* activity name */
    String activityName_;

    @Column("ACTIVITY_NAME")
    public String getActivityName() {
        return activityName_;
    }
    public void setActivityName(String activityName) {
        this.activityName_ = activityName;
    }
    
    /* color color */
    String color_;

    @Column("COLOR")
    public String getColor() {
        return color_;
    }
    public void setColor(String color) {
        this.color_ = color;
    }

    /* meeting basic status id */
    int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }
    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* meeting basic title */
    String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }
    public void setTitle(String title) {
        this.title_ = title;
    }

    /* meeting basic start Date */
    String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }
    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* meeting basic posted User Id */
    int postedUserId_;

    @Column("POSTED_USER_ID")
    public int getPostedUserId() {
        return postedUserId_;
    }
    public void setPostedUserId(int postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* meeting basic bodies body */
    String body_;

    @Column("BODY")
    public String getBody() {
        return body_;
    }
    public void setBody(String body) {
        this.body_ = body;
    }

    /* user id */
    String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }
    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* user last name */
    String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }
    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* task id */
    int taskId_;

    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }
    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }

    /* task title */
    String taskTitle_;

    @Column("TASK_TITLE")
    public String getTaskTitle() {
        return taskTitle_;
    }
    public void setTaskTitle(String taskTitle) {
        this.taskTitle_ = taskTitle;
    }
    
    /* task status id */
    int taskStatusId_;
    
    @Column("TASK_STATUS_ID")
    public int getTaskStatusId() {
        return taskStatusId_;
    }
    public void setTaskStatusId(int taskStatusId) {
        this.taskStatusId_ = taskStatusId;
    }
    
    /* task class id */
    int taskClassId_;
    
    @Column("TASK_CLASS_ID")
    public int getTaskClassId() {
        return taskClassId_;
    }
    public void setTaskClassId(int taskClassId) {
        this.taskClassId_ = taskClassId;
    }
    
    /* task person in charge id */
    int taskPersonId_;
    
    @Column("TASK_PERSON_ID")
    public int getTaskPersonId() {
        return taskPersonId_;
    }
    public void setTaskPersonId(int taskPersonId) {
        this.taskPersonId_ = taskPersonId;
    }
    
    /* task person in charge first name */
    String taskPersonFirstName_;
    
    @Column("TASK_PERSON_FNAME")
    public String getTaskPersonFirstName() {
        return taskPersonFirstName_;
    }
    public void setTaskPersonFirstName(String taskPersonFirstName) {
        this.taskPersonFirstName_ = taskPersonFirstName;
    }
    
    /* task person in charge last name */
    String taskPersonLastName_;

    @Column("TASK_PERSON_LNAME")
    public String getTaskPersonLastName() {
        return taskPersonLastName_;
    }
    public void setTaskPersonLastName(String taskPersonLastName) {
        this.taskPersonLastName_ = taskPersonLastName;
    }
    
    /* meeting basic deleteFlag */
    String deleteFlag_;

    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }
    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* meeting basic registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }
    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* meeting basic modified */
    String modified_;

    @Column("MODIFIED")
    public String getModified() {
        return modified_;
    }
    public void setModified(String modified) {
        this.modified_ = modified;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
