/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.pager.DefaultPagerCondition;

/**
 * meeting browse page condition.
 * 
 * @author naoya.saito
 * 
 */
public class MeetingBrowsePageCondition extends DefaultPagerCondition implements
        Serializable {
    static final long serialVersionUID = 1L;

    /* user id. */
    int userId_;

    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* basic id. */
    int basicId_;

    public int getBasicId() {
        return basicId_;
    }

    public void setBasicId(int basicId) {
        this.basicId_ = basicId;
    }

    /* keyword. */
    String keyword_;

    public String getKeyword() {
        return keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* query status ids. */
    Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query activity ids. */
    Integer[] queryActivityIds_;

    public Integer[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIdsIds(Integer[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query registration ids. */
    Integer[] queryRegistrationIds_;

    public Integer[] getQueryRegistrationIds() {
        return queryRegistrationIds_;
    }

    public void setQueryRegistrationIds(Integer[] queryRegistrationIds) {
        this.queryRegistrationIds_ = queryRegistrationIds;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
