/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting relations.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_relations")
public class MeetingRelation implements Serializable {

    static final long serialVersionUID = 1L;

    /* meeting relations id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* meeting relations basic id */
    int basicId_;

    @Column("BASIC_ID")
    public int getBasicId() {
        return basicId_;
    }

    public void setBasicId(int basicId) {
        this.basicId_ = basicId;
    }

    /* meeting relations agenda id */
    int agendaId_;

    @Column("AGENDA_ID")
    public int getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(int agendaId) {
        this.agendaId_ = agendaId;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
