/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * meeting to task.
 * 
 * @author naoya.saito
 * 
 */
@Bean(table = "meeting_to_tasks")
public class MeetingToTask implements Serializable {
    static final long serialVersionUID = 1L;

    /* row count */
    int rowCount_;

    @Column("ROW_COUNT")
    public int getRowCount() {
        return rowCount_;
    }

    public void setRowCount(int rowCount) {
        this.rowCount_ = rowCount;
    }

    /* meeting to task id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* meeting to task basic id */
    int basicId_;

    @Column("BASIC_ID")
    public int getBasicId() {
        return basicId_;
    }

    public void setBasicId(int basicId) {
        this.basicId_ = basicId;
    }
    
    /* meeting basic title */
    String basicTitle_;
    
    @Column("BASIC_TITLE")
    public String getMeetingTitle() {
        return basicTitle_;
    }
    public void setMeetingTitle(String basicTitle) {
        this.basicTitle_ = basicTitle;
    }

    /* meeting to task agenda id */
    int agendaId_;

    @Column("AGENDA_ID")
    public int getAgendaId() {
        return agendaId_;
    }

    public void setAgendaId(int agendaId) {
        this.agendaId_ = agendaId;
    }

    /* meeting to task discussion id */
    int discussionId_;

    @Column("DISCUSSION_ID")
    public int getDiscussionId() {
        return discussionId_;
    }

    public void setDiscussionId(int discussion) {
        this.discussionId_ = discussion;
    }

    /* meeting to task task id */
    int taskId_;

    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }

    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }

    /* tasks title */
    String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* tasks deadline Date */
    String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* tasks registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* task relations status Id */
    int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* task relations classification id */
    int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* task relations person in charge id */
    int personId_;

    @Column("PERSON_ID")
    public int getPersonId() {
        return personId_;
    }

    public void setPersonId(int personId) {
        this.personId_ = personId;
    }

    /* task relations posted User Id */
    int postedUserId_;

    @Column("POSTED_USER_ID")
    public int getPostedUserId() {
        return postedUserId_;
    }

    public void setPostedUserId(int postedUserId) {
        this.postedUserId_ = postedUserId;
    }

    /* m_user id */
    String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* m_user last name */
    String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
