/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.meeting.page;

/**
 * meeting detail ajax
 * 
 */
public interface MeetingDetailAjax {

    /**
     * get topic list on load
     * @return
     */
    String getAgendaListOnLoad();

    /**
     * update meeting
     * @return
     */
    String updateMeeting();
    
    /**
     * update status
     * @return
     */
    String updateStatus();

    /**
     * add agenda
     * @return
     */
    String addAgenda();

    /**
     * update agenda
     * @return 
     */
    String updateAgenda();

    /**
     * delete agenda
     * @return
     */
    void deleteAgenda();

    /**
     * get agenda discussion.
     * @return
     */
    String getAgendaDiscussion();
    
    /**
     * add agenda discussion
     * @return
     */
    String addAgendaDiscussion();

    /**
     * update agenda discussion
     * @return
     */
    String updateAgendaDiscussion();

    /**
     * delete agenda discussion
     * @return
     */
    void deleteAgendaDiscussion();

    /**
     * get sidebar members contents
     * @return
     */
    String getSidebarMembersContents();

    /**
     * get sidebar tasks contents
     * @return
     */
    String getSidebarTasksContents();
    
    /**
     * send mail
     * @return
     */
    public String sendMail();

}
