/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.Task;

/**
 * Task dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskDto extends Task implements Serializable {
    static final long serialVersionUID = 1L;

    /**
     * get summary
     * 
     * @return
     */
    public String getSummary() {
        return StringUtils.abbreviate(this.getDescription(), 100);
    }

    /* query status ids. */
    Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query classification ids. */
    Integer[] queryClassificationIds_;

    public Integer[] getQueryClassificationIds() {
        return queryClassificationIds_;
    }

    public void setQueryClassificationIds(Integer[] queryClassificationIds) {
        this.queryClassificationIds_ = queryClassificationIds;
    }

    /* query activity ids. */
    Integer[] queryActivityIds_;

    public Integer[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(Integer[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query person ids */
    Integer[] queryPersonIds_;

    public Integer[] getQueryPersonIds() {
        return queryPersonIds_;
    }

    public void setQueryPersonIds(Integer[] queryPersonIds) {
        this.queryPersonIds_ = queryPersonIds;
    }

    /* query person Is Null */
    boolean queryPersonIsNull_;

    public boolean getQueryPersonIsNull() {
        return queryPersonIsNull_;
    }

    public void setQueryPersonIsNull(boolean queryPersonIsNull) {
        this.queryPersonIsNull_ = queryPersonIsNull;
    }

    /* offset */
    int offset_;

    public int getOffset() {
        return offset_;
    }

    public void setOffset(int offset) {
        this.offset_ = offset;
    }

    /* limit */
    int limit_;

    public int getLimit() {
        return limit_;
    }

    public void setLimit(int limit) {
        this.limit_ = limit;
    }

    /* start dateformatted string */
    String startDateformattedString_;

    public String getStartDateformattedString() {
        return startDateformattedString_;
    }

    /* bufferline dateformatted string */
    String bufferlineDateformattedString_;

    public String getBufferlineDateformattedString() {
        return bufferlineDateformattedString_;
    }

    /* deadline dateformatted string */
    String deadlineDateformattedString_;

    public String getDeadlineDateformattedString() {
        return deadlineDateformattedString_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.calendar.entity.Task#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
