/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.tugboat.gtd.contents.task.entity.TaskRelation;

/**
 * Task dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskRelationDto extends TaskRelation implements Serializable {
    static final long serialVersionUID = 1L;

    /* Start date formated */
    String startDateFormated_;

    public String getStartDateFormated() {
        return startDateFormated_;
    }

    public void setStartDateFormated(String startDateFormated) {
        this.startDateFormated_ = startDateFormated;
    }

    /* Deadline formated */
    String deadlinFormated_;

    public String getDeadlineFormated() {
        return deadlinFormated_;
    }

    public void setDeadlineFormated(String deadlineFormated) {
        this.deadlinFormated_ = deadlineFormated;
    }

    /* Registered formated */
    String registeredFormated_;

    public String getRegisteredFormated() {
        return registeredFormated_;
    }

    public void setRegisteredFormated(String registeredFormated) {
        this.registeredFormated_ = registeredFormated;
    }

    /* query status ids. */
    String[] queryStatusIds_;

    public String[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(String[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query classification ids. */
    String[] queryClassificationIds_;

    public String[] getQueryClassificationIds() {
        return queryClassificationIds_;
    }

    public void setQueryClassificationIds(String[] queryClassificationIds) {
        this.queryClassificationIds_ = queryClassificationIds;
    }

    /* query calendar ids. */
    String[] queryActivityIds_;

    public String[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(String[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query person ids */
    String[] queryPersonIds_;

    public String[] getQueryPersonIds() {
        return queryPersonIds_;
    }

    public void setQueryPersonIds(String[] queryPersonIds) {
        this.queryPersonIds_ = queryPersonIds;
    }

    /* query person Is Null */
    boolean queryPersonIsNull_;

    public boolean getQueryPersonIsNull() {
        return queryPersonIsNull_;
    }

    public void setQueryPersonIsNull(boolean queryPersonIsNull) {
        this.queryPersonIsNull_ = queryPersonIsNull;
    }

    /* offset */
    int offset_;

    public int getOffset() {
        return offset_;
    }

    public void setOffset(int offset) {
        this.offset_ = offset;
    }

    /* limit */
    int limit_;

    public int getLimit() {
        return limit_;
    }

    public void setLimit(int limit) {
        this.limit_ = limit;
    }
    
    /* task tags */
    TaskTagDto[] taskTagDtos_;
    
    public TaskTagDto[] getTaskTagDtos() {
        return this.taskTagDtos_;
    }
    
    public void setTaskTagDtos(TaskTagDto[] taskTagDtos) {
        this.taskTagDtos_ = taskTagDtos;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.calendar.entity.Task#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
