/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * Task relations dto.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskRelationsByActivityDto implements Serializable {
    static final long serialVersionUID = 1L;

    /* calendar(activity) id */
    int activityId_;

    public int getActivityId() {
        return activityId_;
    }

    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }

    /* calendar value */
    String activityValue_;

    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* calendar color */
    String activityColor_;

    public String getActivityColor() {
        return activityColor_;
    }

    public void setActivityColor(String activityColor) {
        this.activityColor_ = activityColor;
    }

    /* task number of count */
    public int getRows() {
        return this.taskRelationsDtos_ == null ? 0
                : this.taskRelationsDtos_.length;
    }

    /* tasks */
    TaskRelationDto[] taskRelationsDtos_;

    public TaskRelationDto[] getTaskRelationsDtos() {
        return taskRelationsDtos_;
    }

    public void setTaskDtos(TaskRelationDto[] taskRelationsDtos) {
        this.taskRelationsDtos_ = taskRelationsDtos;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
