/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * task view state relation dto.
 * @author yosuke
 *
 */
public class TaskViewStateRelationDto implements Serializable{
    static final long serialVersionUID = 1L;

    public TaskViewStateRelationDto() {
    }
    
    /* task browser activity dto */
    TaskBrowseActivityDto[] taskBrowseActivityDtos_;
    
    public TaskBrowseActivityDto[] getTaskBrowseActivityDtos() {
        return taskBrowseActivityDtos_;
    }
    
    public void setTaskBrowseActivityDtos(TaskBrowseActivityDto[] taskBrowseActivityDtos) {
        this.taskBrowseActivityDtos_ = taskBrowseActivityDtos;
    }
    
    public List<Integer> getTaskBrowseActivities() {
        if (this.taskBrowseActivityDtos_ == null
         || this.taskBrowseActivityDtos_.length == 0) return null;
        
        List<Integer> result = new ArrayList<Integer>();
        for (int i = 0; i < this.taskBrowseActivityDtos_.length; i++) {
            result.add(this.taskBrowseActivityDtos_[i].getActivityId());
        }
        return result;
    }
    
    /* task browse classification dto */
    TaskBrowseClassificationDto[] taskBrowseClassificationDtos_;
    
    public TaskBrowseClassificationDto[] getTaskBrowseClassificationDtos() {
        return taskBrowseClassificationDtos_;
    }
    
    public void setTaskBrowseClassificationDtos(TaskBrowseClassificationDto[] taskBrowseClassificationDtos) {
        this.taskBrowseClassificationDtos_ = taskBrowseClassificationDtos;
    }
    
    public List<Integer> getTaskBrowseClassifications() {
        if (this.taskBrowseClassificationDtos_ == null 
         || this.taskBrowseClassificationDtos_.length == 0) return null;
        
        List<Integer> result = new ArrayList<Integer>();
        for (int i = 0; i < this.taskBrowseClassificationDtos_.length; i++) {
            result.add(this.taskBrowseClassificationDtos_[i].getClassId());
        }
        return result;
    }
    
    /* task browse person dtos */
    TaskBrowsePersonDto[] taskBrowsePersonDtos_;
    
    public TaskBrowsePersonDto[] getTaskBrowsePersonDtos() {
        return taskBrowsePersonDtos_;
    }
    
    public void setTaskBrowsePersonDto(TaskBrowsePersonDto[] taskBrowsePersonDtos) {
        this.taskBrowsePersonDtos_ = taskBrowsePersonDtos;
    }
    
    public List<Integer> getTaskBrowsePersons() {
        if (this.taskBrowsePersonDtos_ == null
         || this.taskBrowsePersonDtos_.length == 0) return null;
        
        List<Integer> result = new ArrayList<Integer>();
        for (int i = 0; i < this.taskBrowsePersonDtos_.length; i++) {
            result.add(this.taskBrowsePersonDtos_[i].getPersonId());
        }
        return result;
    }
    
    /* task browse status dtos */
    TaskBrowseStatusDto[] taskBrowseStatusDtos_;
    
    public TaskBrowseStatusDto[] getTaskBrowseStatusDtos() {
        return taskBrowseStatusDtos_;
    }
    
    public void setTaskBrowseStatusDtos(TaskBrowseStatusDto[] taskBrowseStatusDtos) {
        this.taskBrowseStatusDtos_ = taskBrowseStatusDtos;
    }
    
    public List<Integer> getTaskBrowseStatuses() {
        if (this.taskBrowseStatusDtos_ == null 
         || this.taskBrowseStatusDtos_.length == 0) return null;

        List<Integer> result = new ArrayList<Integer>();
        for (int i=0; i <this.taskBrowseStatusDtos_.length; i++) {
            result.add(this.taskBrowseStatusDtos_[i].getStatusId());
        }
        return result;
    }
    
    /* task select view dto */
    TaskSelectViewDto taskSelectViewDto_;
    
    public TaskSelectViewDto getTaskSelectViewDto() {
        return taskSelectViewDto_;
    }
    
    public void setTaskSelectViewDto(TaskSelectViewDto taskSelectViewDto) {
        this.taskSelectViewDto_ = taskSelectViewDto;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
