/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;

/**
 * tag.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "tags")
public class Tag implements Serializable {
    static final long serialVersionUID = 1L;
    
    public Tag() {}
    public Tag(int id, String value) {
        this.id_ = id;
        this.value_ = value;
    }
    public Tag(int id, String value, int numberOfCount) {
        this.id_ = id;
        this.value_ = value;
        this.numberOfCount_ = numberOfCount;
    }
    
    /* id */
    int id_;
    
    public int getId() {
        return id_;
    }
    
    public void setId(int id) {
        this.id_ = id;
    }
    
    /* value */
    String value_;
    
    public String getValue() {
        return value_;
    }
    
    public void setValue(String value) {
        this.value_ = value;
    }
    
    /* number of count */
    int numberOfCount_;
    
    public int getNumberOfCount() {
        return numberOfCount_;
    }
    
    public void setNumberOfCount(int numberOfCount) {
        this.numberOfCount_ = numberOfCount;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
