/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "tasks")
public class Task implements Serializable {
    static final long serialVersionUID = 1L;

    public static final int STATUS_TODO = 1;

    public static final int STATUS_DOING = 2;

    public static final int STATUS_DONE = 3;

    /* Id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* Title */
    String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* description */
    String description_ = "";

    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* description textile */
    String descriptionTextile_ = "";

    public String getDescriptionTextile() {
        return descriptionTextile_;
    }

    public void setDescriptionTextile(String descriptionTextile) {
        this.descriptionTextile_ = descriptionTextile;
    }

    /* share */
    int share_;

    @Column("SHARE")
    public int getShare() {
        return share_;
    }

    public void setShare(int share) {
        this.share_ = share;
    }

    /* Start date */
    String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* Start year */
    int startYear_;

    @Column("START_YEAR")
    public int getStartYear() {
        return startYear_;
    }

    public void setStartYear(int startYear) {
        this.startYear_ = startYear;
    }

    /* Start month */
    int startMonth_;

    @Column("START_MONTH")
    public int getStartMonth() {
        return startMonth_;
    }

    public void setStartMonth(int startMonth) {
        this.startMonth_ = startMonth;
    }

    /* Start day of month */
    int startDayOfMonth_;

    @Column("START_DAY_OF_MONTH")
    public int getStartDayOfMonth() {
        return startDayOfMonth_;
    }

    public void setStartDayOfMonth(int startDayOfMonth) {
        this.startDayOfMonth_ = startDayOfMonth;
    }

    /* deadline Date */
    String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* deadline year */
    int deadlineYear_;

    @Column("DEAD_LINE_YEAR")
    public int getDeadlineYear() {
        return deadlineYear_;
    }

    public void setDeadlineYear(int deadlineYear) {
        this.deadlineYear_ = deadlineYear;
    }

    /* deadline month */
    int deadlineMonth_;

    @Column("DEAD_LINE_MONTH")
    public int getDeadlineMonth() {
        return deadlineMonth_;
    }

    public void setDeadlineMonth(int deadlineMonth) {
        this.deadlineMonth_ = deadlineMonth;
    }

    /* deadline day of month */
    int deadlineDayOfMonth_;

    @Column("DEAD_LINE_DAY_OF_MONTH")
    public int getDeadlineDayOfMonth() {
        return deadlineDayOfMonth_;
    }

    public void setDeadlineDayOfMonth(int deadlineDayOfMonth) {
        this.deadlineDayOfMonth_ = deadlineDayOfMonth;
    }

    /* privacy */
    int privacy_;

    @Column("PRIVACY")
    public int getPrivacy() {
        return privacy_;
    }

    public void setPrivacy(int privacy) {
        this.privacy_ = privacy;
    }

    /* priority order */
    int priorityOrder_;

    @Column("PRIORITY_ORDER")
    public int getPriorityOrder() {
        return priorityOrder_;
    }

    public void setPriorityOrder(int priorityOrder) {
        this.priorityOrder_ = priorityOrder;
    }

    /* status Id */
    int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* status value */
    String statusValue_;

    @Column("STATUS_VALUE")
    public String getStatusValue() {
        return statusValue_;
    }

    public void setStatusValue(String statusValue) {
        this.statusValue_ = statusValue;
    }

    /* activity id */
    int activityId_;

    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }

    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    String activityValue_;

    @Column("ACTIVITY_VALUE")
    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* classification id */
    int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* classification value */
    String classificationValue_;

    @Column("CLASSIFICATION_VALUE")
    public String getClassificationValue() {
        return classificationValue_;
    }

    public void setClassificationValue(String classificationValue) {
        this.classificationValue_ = classificationValue;
    }

    /* user id */
    int userId_;

    @Column("POSTED_USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* user first name */
    String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }
    
    /* delete flag */
    String deleteFlag_ = "0";
    
    @Column("DELETE_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }
    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
