/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.pager.DefaultPagerCondition;

/**
 * Task browse page condition.
 * 
 * @author yousuke.hara
 * 
 */
public class TaskBrowsePageCondition extends DefaultPagerCondition implements Serializable {
    static final long serialVersionUID = 1L;

    /* user id. */
    int userId_;

    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* keyword. */
    String keyword_;

    public String getKeyword() {
        return keyword_;
    }

    public void setKeyword(String keyword) {
        this.keyword_ = keyword;
    }

    /* query status ids. */
    Integer[] queryStatusIds_;

    public Integer[] getQueryStatusIds() {
        return queryStatusIds_;
    }

    public void setQueryStatusIds(Integer[] queryStatusIds) {
        this.queryStatusIds_ = queryStatusIds;
    }

    /* query classification ids. */
    Integer[] queryClassificationIds_;

    public Integer[] getQueryClassificationIds() {
        return queryClassificationIds_;
    }

    public void setQueryClassificationIds(Integer[] queryClassificationIds) {
        this.queryClassificationIds_ = queryClassificationIds;
    }

    /* query activity ids. */
    Integer[] queryActivityIds_;

    public Integer[] getQueryActivityIds() {
        return queryActivityIds_;
    }

    public void setQueryActivityIds(Integer[] queryActivityIds) {
        this.queryActivityIds_ = queryActivityIds;
    }

    /* query person ids. */
    Integer[] queryPersonIds_;

    public Integer[] getQueryPersonIds() {
        return queryPersonIds_;
    }

    public void setQueryPersonIds(Integer[] queryPersonIds) {
        this.queryPersonIds_ = queryPersonIds;
    }

    /* query person Is Null */
    boolean queryPersonIsNull_;

    public boolean getQueryPersonIsNull() {
        return queryPersonIsNull_;
    }

    public void setQueryPersonIsNull(boolean queryPersonIsNull) {
        this.queryPersonIsNull_ = queryPersonIsNull;
    }
    
    /* query tag which has task ids. */
    Integer[] taskIds_;
    
    public Integer[] getTaskIds() {
        return taskIds_;
    }
    
    public void setTaskIds(Integer[] taskIds) {
        this.taskIds_ = taskIds;
    }
    
    /* query tag ids */
    Integer[] tagIds_;
    
    public Integer[] getTagIds() {
        return tagIds_;
    }
    
    public void setTagIds(Integer[] tagIds) {
        this.tagIds_ = tagIds;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
