/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task comment.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_comments")
public class TaskComment implements Serializable {
    static final long serialVersionUID = 1L;

    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* task Id */
    int taskId_;

    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }

    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }

    /* comment */
    String comment_;

    @Column("BODY")
    public String getComment() {
        return comment_;
    }

    public void setComment(String comment) {
        this.comment_ = comment;
    }

    /* user Id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* user first name */
    String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* photo url */
    String photoUrl_;

    @Column("PHOTO_IMG_URL")
    public String getPhotoUrl() {
        return photoUrl_;
    }

    public void setPhotoUrl(String photoUrl) {
        this.photoUrl_ = photoUrl;
    }

    /* color id */
    int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color value */
    String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
