/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_relations")
public class TaskRelation implements Serializable {
    static final long serialVersionUID = 1L;

    /** status todo */
    public static final int STATUS_TODO = 1;
    /** status doing */
    public static final int STATUS_DOING = 2;
    /** status done */
    public static final int STATIS_DONE = 3;

    /* Id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* task id */
    int taskId_;

    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }

    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }

    /* Title */
    String title_;

    @Column("TITLE")
    public String getTitle() {
        return title_;
    }

    public void setTitle(String title) {
        this.title_ = title;
    }

    /* description */
    String description_ = "";

    @Column("BODY")
    public String getDescription() {
        return description_;
    }

    public void setDescription(String description) {
        this.description_ = description;
    }

    /* description textile */
    String descriptionTextile_ = "";

    public String getDescriptionTextile() {
        return descriptionTextile_;
    }

    public void setDescriptionTextile(String descriptionTextile) {
        this.descriptionTextile_ = descriptionTextile;
    }

    /* share */
    int share_;

    @Column("SHARE")
    public int getShare() {
        return share_;
    }

    public void setShare(int share) {
        this.share_ = share;
    }

    /* Start date */
    String startDate_;

    @Column("START_DATE")
    public String getStartDate() {
        return startDate_;
    }

    public void setStartDate(String startDate) {
        this.startDate_ = startDate;
    }

    /* Start year */
    int startYear_;

    @Column("START_YEAR")
    public int getStartYear() {
        return startYear_;
    }

    public void setStartYear(int startYear) {
        this.startYear_ = startYear;
    }

    /* Start month */
    int startMonth_;

    @Column("START_MONTH")
    public int getStartMonth() {
        return startMonth_;
    }

    public void setStartMonth(int startMonth) {
        this.startMonth_ = startMonth;
    }

    /* Start day of month */
    int startDayOfMonth_;

    @Column("START_DAY_OF_MONTH")
    public int getStartDayOfMonth() {
        return startDayOfMonth_;
    }

    public void setStartDayOfMonth(int startDayOfMonth) {
        this.startDayOfMonth_ = startDayOfMonth;
    }

    /* deadline Date */
    String deadline_;

    @Column("DEAD_LINE")
    public String getDeadline() {
        return deadline_;
    }

    public void setDeadline(String deadline) {
        this.deadline_ = deadline;
    }

    /* deadline year */
    int deadlineYear_;

    @Column("DEAD_LINE_YEAR")
    public int getDeadlineYear() {
        return deadlineYear_;
    }

    public void setDeadlineYear(int deadlineYear) {
        this.deadlineYear_ = deadlineYear;
    }

    /* deadline month */
    int deadlineMonth_;

    @Column("DEAD_LINE_MONTH")
    public int getDeadlineMonth() {
        return deadlineMonth_;
    }

    public void setDeadlineMonth(int deadlineMonth) {
        this.deadlineMonth_ = deadlineMonth;
    }

    /* deadline day of month */
    int deadlineDayOfMonth_;

    @Column("DEAD_LINE_DAY_OF_MONTH")
    public int getDeadlineDayOfMonth() {
        return deadlineDayOfMonth_;
    }

    public void setDeadlineDayOfMonth(int deadlineDayOfMonth) {
        this.deadlineDayOfMonth_ = deadlineDayOfMonth;
    }

    /* privacy */
    int privacy_;

    @Column("PRIVACY")
    public int getPrivacy() {
        return privacy_;
    }

    public void setPrivacy(int privacy) {
        this.privacy_ = privacy;
    }

    /* priority order */
    int priorityOrder_;

    @Column("PRIORITY_ORDER")
    public int getPriorityOrder() {
        return priorityOrder_;
    }

    public void setPriorityOrder(int priorityOrder) {
        this.priorityOrder_ = priorityOrder;
    }

    /* status Id */
    int statusId_;

    @Column("STATUS_ID")
    public int getStatusId() {
        return statusId_;
    }

    public void setStatusId(int statusId) {
        this.statusId_ = statusId;
    }

    /* status value */
    String statusValue_;

    @Column("STATUS_VALUE")
    public String getStatusValue() {
        return statusValue_;
    }

    public void setStatusValue(String statusValue) {
        this.statusValue_ = statusValue;
    }

    /* activity id */
    int activityId_;

    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }

    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }

    /* activity name */
    String activityValue_;

    @Column("ACTIVITY_VALUE")
    public String getActivityValue() {
        return activityValue_;
    }

    public void setActivityValue(String activityValue) {
        this.activityValue_ = activityValue;
    }

    /* color id */
    int colorId_;

    @Column("COLOR_ID")
    public int getColorId() {
        return colorId_;
    }

    public void setColorId(int colorId) {
        this.colorId_ = colorId;
    }

    /* color value */
    String colorValue_;

    @Column("COLOR_VALUE")
    public String getColorValue() {
        return colorValue_;
    }

    public void setColorValue(String colorValue) {
        this.colorValue_ = colorValue;
    }

    /* classification id */
    int classificationId_;

    @Column("CLASSIFICATION_ID")
    public int getClassificationId() {
        return classificationId_;
    }

    public void setClassificationId(int classificationId) {
        this.classificationId_ = classificationId;
    }

    /* classification value */
    String classificationValue_;

    @Column("CLASSIFICATION_VALUE")
    public String getClassificationValue() {
        return classificationValue_;
    }

    public void setClassificationValue(String classificationValue) {
        this.classificationValue_ = classificationValue;
    }

    /* alert id */
    int alertId_;

    @Column("ALERT_ID")
    public int getAlertId() {
        return alertId_;
    }

    public void setAlertId(int alertId) {
        this.alertId_ = alertId;
    }

    /* alert value */
    String alertValue_;

    @Column("ALERT_VALUE")
    public String getAlertValue() {
        return alertValue_;
    }

    public void setAlertValue(String alertValue) {
        this.alertValue_ = alertValue;
    }

    /* person in charge id */
    int personInChargeId_;

    @Column("PERSON_ID")
    public int getPersonInChargeId() {
        return personInChargeId_;
    }

    public void setPersonInChargeId(int personInChargeId) {
        this.personInChargeId_ = personInChargeId;
    }

    /* preson in charge.first name */
    String personInChargeFirstName_;

    @Column("PERSON_FIRST_NAME")
    public String getPersonInChargeFirstName() {
        return personInChargeFirstName_;
    }

    public void setPersonInChargeFirstName(String personInChargeFirstName) {
        this.personInChargeFirstName_ = personInChargeFirstName;
    }

    /* person in charge last name */
    String personInChargeLastName_;

    @Column("PERSON_LAST_NAME")
    public String getPersonInChargeLastName() {
        return personInChargeLastName_;
    }

    public void setPersonInChargeLastName(String personInChargeLastName) {
        this.personInChargeLastName_ = personInChargeLastName;
    }

    /* user id */
    int userId_;

    @Column("POSTED_USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* user first name */
    String userFirstName_;

    @Column("FIRST_NAME")
    public String getUserFirstName() {
        return userFirstName_;
    }

    public void setUserFirstName(String userFirstName) {
        this.userFirstName_ = userFirstName;
    }

    /* user last name */
    String userLastName_;

    @Column("LAST_NAME")
    public String getUserLastName() {
        return userLastName_;
    }

    public void setUserLastName(String userLastName) {
        this.userLastName_ = userLastName;
    }

    /* delete flag */
    int deleteFlag_;

    @Column("DEL_FLAG")
    public int getDeleteFlag() {
        return deleteFlag_;
    }

    public void setDeleteFlag(int deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }

    /* posted date time */
    String postedDateTime_;

    public String getPostedDateTime() {
        return postedDateTime_;
    }

    public void setPostedDateTime(String postedDateTime) {
        this.postedDateTime_ = postedDateTime;
    }

    /* rows */
    int rows_;

    @Column("RECORDS")
    public int getRows() {
        return rows_;
    }

    public void setRows(int rows) {
        this.rows_ = rows;
    }

    /* inbox task rows */
    int inboxTasks_;

    @Column("INBOX_TASKS")
    public int getInboxTasks() {
        return inboxTasks_;
    }

    public void setInboxTasks(int inboxTasks) {
        this.inboxTasks_ = inboxTasks;
    }

    /* today task rows */
    int todayTasks_;

    @Column("TODAY_TASKS")
    public int getTodayTasks() {
        return todayTasks_;
    }

    public void setTodayTasks(int todayTasks) {
        this.todayTasks_ = todayTasks;
    }

    /* today todo tasks */
    int todayTodoTasks_;

    @Column("TODAY_TODO_TASKS")
    public int getTodayTodoTasks() {
        return todayTodoTasks_;
    }

    public void setTodayTodoTasks(int todayTodoTasks) {
        this.todayTodoTasks_ = todayTodoTasks;
    }

    /* today doing tasks */
    int todayDoingTasks_;

    @Column("TODAY_DOING_TASKS")
    public int getTodayDoingTasks() {
        return todayDoingTasks_;
    }

    public void setTodayDoingTasks(int todayDoingTasks) {
        this.todayDoingTasks_ = todayDoingTasks;
    }

    /* today done tasks */
    int todayDoneTasks_;

    @Column("TODAY_DONE_TASKS")
    public int getTodayDoneTasks() {
        return todayDoneTasks_;
    }

    public void setTodayDoneTasks(int todayDoneTasks) {
        this.todayDoneTasks_ = todayDoneTasks;
    }

    /* week task rows */
    int weekTasks_;

    @Column("WEEK_TASKS")
    public int getWeekTasks() {
        return weekTasks_;
    }

    public void setWeekTasks(int weekTasks) {
        this.weekTasks_ = weekTasks;
    }
    
    /* month tasks */
    int monthTasks_;
    
    @Column("MONTH_TASKS")
    public int getMonthTasks() {
        return monthTasks_;
    }
    public void setMonthTasks(int monthTasks) {
        this.monthTasks_ = monthTasks;
    }

    /* hold task rows */
    int holdTasks_;

    @Column("HOLD_TASKS")
    public int getHoldTasks() {
        return holdTasks_;
    }

    public void setHoldTasks(int holdTasks) {
        this.holdTasks_ = holdTasks;
    }

    /* someday task rows */
    int somedayTasks_;

    @Column("SOMEDAY_TASKS")
    public int getSomedayTasks() {
        return somedayTasks_;
    }

    public void setSomedayTasks(int somedayTasks) {
        this.somedayTasks_ = somedayTasks;
    }

    /* archive task rows */
    int archiveTasks_;

    @Column("ARCHIVE_TASKS")
    public int getArchiveTasks() {
        return archiveTasks_;
    }

    public void setArchiveTasks(int archiveTasks) {
        this.archiveTasks_ = archiveTasks;
    }

    /* trash bos tasks */
    int trashBoxTasks_;
    
    @Column("TRASH_BOX_TASKS")
    public int getTrashBoxTasks() {
        return trashBoxTasks_;
    }
    
    public void setTrashBoxTasks(int trashBoxTasks) {
        this.trashBoxTasks_ = trashBoxTasks;
    }
    
    /* registered */
    String registered_;

    @Column("REGISTERED")
    public String getRegistered() {
        return registered_;
    }

    public void setRegistered(String registered) {
        this.registered_ = registered;
    }

    /* tag id */
    Integer tagId_;
    
    @Column("TAG_ID")
    public Integer getTagId() {
        return tagId_;
    }
    
    public void setTagId(Integer tagId) {
        this.tagId_ = tagId;
    }
    
    /* tag value */
    String tagValue_;
    
    @Column("TAG_VALUE")
    public String getTagValue() {
        return tagValue_;
    }
    
    public void setTagValue(String tagValue) {
        this.tagValue_ = tagValue;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
