/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;
import org.seasar.tugboat.gtd.contents.common.entity.Classification;

/**
 * task select view.
 * @author yosuke
 *
 */
@Bean(table = "task_select_views")
public class TaskSelectView implements Serializable {
    static final long serialVersionUID = 1L;

    public TaskSelectView() {
    }

    public TaskSelectView(int classId, int userId) {
        this.classId_ = classId;
        this.userId_ = userId;
    }
    
    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* mode id */
    int modeId_;

    @Column("MODE_ID")
    public int getModeId() {
        return modeId_;
    }

    public void setModeId(int modeId) {
        this.modeId_ = modeId;
    }
    
    /* class id */
    int classId_ = Classification.INBOX;
    
    @Column("CLASS_ID")
    public int getClassId() {
        return classId_;
    }
    
    public void setClassId(int classId) {
        this.classId_ = classId;
    }
    
    /* is visible browser */
    int isVisibleBrowser_;
    
    @Column("IS_ViSIBLE_BROWSER")
    public int getIsVisibleBrowser() {
        return isVisibleBrowser_;
    }
    
    public void setIsVisibleBrowser(int isVisibleBrowser) {
        this.isVisibleBrowser_ = isVisibleBrowser;
    }
    
    /* selected tab id */
    int selectedTabId_;
    
    @Column("SELECTED_TAB_ID")
    public int getSelectedTabId() {
        return selectedTabId_;
    }
    
    public void setSelectedTabId(int selectedTabId) {
        this.selectedTabId_ = selectedTabId;
    }

    /* user id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
