/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * Task tag.
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "task_tags")
public class TaskTag implements Serializable {
    static final long serialVersionUID = 1L;

    public TaskTag(){
    }
    public TaskTag(int id, String tagValue) {
        this.id_ = id;
        this.tagValue_ = tagValue;
    }
    
    /* Id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* activity id */
    int activityId_;
    
    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }
    
    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }
    
    /* task id */
    int taskId_;

    @Column("TASK_ID")
    public int getTaskId() {
        return taskId_;
    }

    public void setTaskId(int taskId) {
        this.taskId_ = taskId;
    }

    /* tag id */
    int tagId_;

    @Column("TAG_ID")
    public int getTagId() {
        return tagId_;
    }

    public void setTagId(int tagId) {
        this.tagId_ = tagId;
    }
    
    /* tag value */
    String tagValue_;

    @Column("TAG_VALUE")
    public String getTagValue() {
        return tagValue_;
    }

    public void setTagValue(String tagValue) {
        this.tagValue_ = tagValue;
    }

    /* user id */
    int userId_;

    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* posted at */
    String postedAt_;

    @Column("POSTED_AT")
    public String getPostedAt() {
        return postedAt_;
    }

    public void setPostedAt(String postedAt) {
        this.postedAt_ = postedAt;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
