/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * task 2 task.
 * 
 * @author yosuke
 * 
 */
@Bean(table = "task_to_tasks")
public class TaskToTask implements Serializable {
    static final long serialVersionUID = 1L;

    /* id */
    int id_;

    @Column("ID")
    public int getId() {
        return id_;
    }

    public void setId(int id) {
        this.id_ = id;
    }

    /* source task id */
    int sourceTaskId_;

    @Column("SRC_TASK_ID")
    public int getSourceTaskId() {
        return sourceTaskId_;
    }

    public void setSourceTaskId(int sourceTaskId) {
        this.sourceTaskId_ = sourceTaskId;
    }

    /* source activity id */
    int sourceActivityId_;

    @Column("SRC_ACTIVITY_ID")
    public int getSourceActivityId() {
        return sourceActivityId_;
    }

    public void setSourceActivityId(int sourceActivityId) {
        this.sourceActivityId_ = sourceActivityId;
    }

    /* source status id */
    int sourceStatusId_;

    @Column("SRC_STATUS_ID")
    public int getSourceStatusId() {
        return sourceStatusId_;
    }

    public void setSourceStatusId(int sourceStatusId) {
        this.sourceStatusId_ = sourceStatusId;
    }

    /* source classification id */
    int sourceClassificationId_;

    @Column("SRC_CLASS_ID")
    public int getSourceClassificationId() {
        return sourceClassificationId_;
    }

    public void setSourceClassificationId(int sourceClassificationId) {
        this.sourceClassificationId_ = sourceClassificationId;
    }

    /* source title */
    String sourceTitle_;

    @Column("SRC_TITLE")
    public String getSourceTitle() {
        return sourceTitle_;
    }

    public void setSourceTitle(String sourceTitle) {
        this.sourceTitle_ = sourceTitle;
    }

    /* source description */
    String sourceDescription_;

    @Column("SRC_DESCRIPTION")
    public String getSourceDescription() {
        return sourceDescription_;
    }

    public void setSourceDescription(String sourceDescription) {
        this.sourceDescription_ = sourceDescription;
    }
    
    /* source due */
    String sourceDue_;
    
    @Column("SRC_DUE")
    public String getSourceDue() {
    	return sourceDue_;
    }
    public void setSourceDue(String sourceDue) {
    	this.sourceDue_ = sourceDue;
    }

    /* source posted at */
    String sourcePostedAt_;

    @Column("SRC_POSTED_AT")
    public String getSourcePostedAt() {
        return sourcePostedAt_;
    }

    public void setSourcePostedAt(String sourcePostedAt) {
        this.sourcePostedAt_ = sourcePostedAt;
    }

    /* source posted by */
    String sourcePostedBy_;

    @Column("SRC_POSTED_BY")
    public String getSourcePostedBy() {
        return sourcePostedBy_;
    }

    public void setSourcePostedBy(String sourcePostedBy) {
        this.sourcePostedBy_ = sourcePostedBy;
    }

    /* source posted user id */
    int sourcePostedUserId_;

    @Column("SRC_POSTED_USER_ID")
    public int getSourcePostedUserId() {
        return sourcePostedUserId_;
    }

    public void setSourcePostedUserId(int sourcePostedUserId) {
        this.sourcePostedUserId_ = sourcePostedUserId;
    }

    /* destination task id */
    int destinationTaskId_;

    @Column("DEST_TASK_ID")
    public int getDestinationTaskId() {
        return destinationTaskId_;
    }

    public void setDestinationTaskId(int destinationTaskId) {
        this.destinationTaskId_ = destinationTaskId;
    }

    /* destination activity id */
    int destinationActivityId_;

    @Column("DEST_ACTIVITY_ID")
    public int getDestinationActivityId() {
        return destinationActivityId_;
    }

    public void setDestinationActivityId(int destinationActivityId) {
        this.destinationActivityId_ = destinationActivityId;
    }

    /* destination status id */
    int destinationStatusId_;

    @Column("DEST_STATUS_ID")
    public int getDestinationStatusId() {
        return destinationStatusId_;
    }

    public void setDestinationStatusId(int destinationStatusId) {
        this.destinationStatusId_ = destinationStatusId;
    }

    /* destination classification id */
    int destinationClassificationId_;

    @Column("DEST_CLASS_ID")
    public int getDestinationClassificationId() {
        return destinationClassificationId_;
    }

    public void setDestinationClassificationId(int destinationClassificationId) {
        this.destinationClassificationId_ = destinationClassificationId;
    }

    /* destination title */
    String destinationTitle_;

    @Column("DEST_TITLE")
    public String getDestinationTitle() {
        return destinationTitle_;
    }

    public void setDestinationTitle(String destinationTitle) {
        this.destinationTitle_ = destinationTitle;
    }

    /* destination description */
    String destinationDescription_;

    @Column("DEST_DESCRIPTION")
    public String getDestinationDescription() {
        return destinationDescription_;
    }

    public void setDestinationDescription(String destinationDescription) {
        this.destinationDescription_ = destinationDescription;
    }
    
    /* destination posted at */
    String destinationPostedAt_;

    @Column("DEST_POSTED_AT")
    public String getDestinationPostedAt() {
        return destinationPostedAt_;
    }

    public void setDestinationPostedAt(String destinationPostedAt) {
        this.destinationPostedAt_ = destinationPostedAt;
    }

    /* destination posted by */
    String destinationPostedBy_;

    @Column("DEST_POSTED_BY")
    public String getDestinationPostedBy() {
        return destinationPostedBy_;
    }

    public void setDestinationPostedBy(String destinationPostedBy) {
        this.destinationPostedBy_ = destinationPostedBy;
    }

    /* destination posted user id */
    int destinationPostedUserId_;

    @Column("DEST_POSTED_USER_ID")
    public int getDestinationPostedUserId() {
        return destinationPostedUserId_;
    }

    public void setDestinationPostedUserId(int destinationPostedUserId) {
        this.destinationPostedUserId_ = destinationPostedUserId;
    }
    
    /* destination person in charge id */
    int destinationPersonInChargeId_;
    
    @Column("DEST_PERSON_ID")
    public int getDestinationPersonInChargeId() {
        return destinationPersonInChargeId_;
    }
    public void setDestinationPersonInChargeId(int destinationPersonInChargeId) {
        this.destinationPersonInChargeId_ = destinationPersonInChargeId;
    }
    
    /* destination person in charge name */
    String destinationPersonInChargeName_;
    
    @Column("DEST_PERSON_NAME")
    public String getDestinationPersonInChargeName() {
        return destinationPersonInChargeName_;
    }
    public void setDestinationPersonInChargeName(String destinationPersonInChargeName) {
        this.destinationPersonInChargeName_ = destinationPersonInChargeName;
    }
    
    /* destination due */
    String destinationDue_;
    
    @Column("DEST_DUE")
    public String getDestinationDue() {
        return destinationDue_;
    }
    public void setDestinationDue(String destinationDue) {
        this.destinationDue_ = destinationDue;
    }
    
    /* destination tags */
    String[] destinationTags_;
    public String[] getDestinationTags() {
        return destinationTags_;
    }
    public void setDestinationTags(String[] destinationTags) {
        this.destinationTags_ = destinationTags;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
