/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.task.page;

/**
 * gtd task Ajax.
 * 
 * @author yousuke.hara
 * 
 */
public interface TaskAjax {

    /**
     * Add task.
     * 
     * @return
     */
    String add();

    /**
     * get activities json.
     * 
     * @return
     */
    String getActivitiesJSON();

    /**
     * get task list by params.
     * 
     * @return
     */
    String getTaskListByQueryParams();

    /**
     * get default folder tasks.
     * 
     * @return
     */
    String getDefaultFolderTasks();

    /**
     * get task for balloon's json.
     * 
     * @return
     */
    String getTaskForBalloonJSON();

    /**
     * update tasks's classification.
     * 
     * @return
     */
    String updateClassification();

    /**
     * empty a trash box.
     * 
     * @return
     */
    String emptyTrashBox();

    /**
     * select mode block or list.
     * 
     * @return
     */
    String selectModeBlockOrList();

    /**
     * get before view statuses json.
     * 
     * @return
     */
    String getBeforeViewStatusesJSON();

    /**
     * update is visible browser.
     * 
     * @return
     */
    String updateIsVisibleBrowser();
    
    /**
     * update selected tab.
     * 
     * @return
     */
    String updateSelectedTab();
    
    /**
     * find task by has tags.
     * 
     * @return
     */
    String findTasksByHasTags();
    
    /**
     * get calendar list.
     * 
     * @return
     */
    String getDueList();
    
    /**
     * get tasks by due.
     * 
     * @return
     */
    String getTasksByDue();
}
