package org.seasar.tugboat.gtd.contents.task.service;

import org.seasar.tugboat.gtd.contents.task.dto.TaskCommentBodyDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskCommentDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskToTaskDto;

/**
 * task detail service.
 * 
 * @author yosuke
 * 
 */
public interface TaskDetailService {
    /**
     * add task comment.
     * @param commentDto
     * @param bodyDto
     * @return
     */
    TaskCommentDto[] addTaskComment(
            TaskCommentDto commentDto, TaskCommentBodyDto bodyDto);
    
    /**
     * get comment by task id.
     * @param taskId
     * @return
     */
    TaskCommentDto[] getTaskCommentsByTaskId(int taskId);
    
    /**
     * get task comment by comment id.
     * @param commentId
     * @return
     */
    TaskCommentDto getTaskCommentByCommentId(int commentId);
    
    /**
     * update comment.
     * @param bodyDto
     */
    void updateTaskComment(TaskCommentBodyDto bodyDto);
    
    /**
     * delete comment.
     * @param bodyDto
     */
    void deleteTaskComment(TaskCommentBodyDto bodyDto);
    
    /**
     * add task to tasks.
     * @param taskToTasksDto
     */
    void addTaskToTasks(TaskToTaskDto taskToTasksDto);
    
    /**
     * get task to tasks by task id.
     * @param taskId
     * @return
     */
    TaskToTaskDto[] getTaskToTasksByTaskId(int taskId);

}
