package org.seasar.tugboat.gtd.contents.task.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.seasar.framework.log.Logger;
import org.seasar.tugboat.gtd.container.service.SearchService;
import org.seasar.tugboat.gtd.contents.activity.dao.ActivitiesDao;
import org.seasar.tugboat.gtd.contents.activity.dao.ActivityMembersDao;
import org.seasar.tugboat.gtd.contents.activity.dto.ActivityDto;
import org.seasar.tugboat.gtd.contents.activity.dxo.ActivityDxo;
import org.seasar.tugboat.gtd.contents.activity.entity.Activity;
import org.seasar.tugboat.gtd.contents.activity.entity.ActivityMember;
import org.seasar.tugboat.gtd.contents.meeting.dao.MeetingToTasksDao;
import org.seasar.tugboat.gtd.contents.task.dao.TagsDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskBodiesDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskCommentBodiesDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskCommentRelatiosDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskCommentsDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskHistoriesDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskRelationsDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskTagsDao;
import org.seasar.tugboat.gtd.contents.task.dao.TaskToTasksDao;
import org.seasar.tugboat.gtd.contents.task.dao.TasksDao;
import org.seasar.tugboat.gtd.contents.task.dto.TaskCommentBodyDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskCommentDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskRelationDto;
import org.seasar.tugboat.gtd.contents.task.dto.TaskToTaskDto;
import org.seasar.tugboat.gtd.contents.task.dxo.TaskDxo;
import org.seasar.tugboat.gtd.contents.task.entity.Tag;
import org.seasar.tugboat.gtd.contents.task.entity.Task;
import org.seasar.tugboat.gtd.contents.task.entity.TaskBody;
import org.seasar.tugboat.gtd.contents.task.entity.TaskComment;
import org.seasar.tugboat.gtd.contents.task.entity.TaskCommentBody;
import org.seasar.tugboat.gtd.contents.task.entity.TaskCommentRelation;
import org.seasar.tugboat.gtd.contents.task.entity.TaskHistory;
import org.seasar.tugboat.gtd.contents.task.entity.TaskRelation;
import org.seasar.tugboat.gtd.contents.task.entity.TaskTag;
import org.seasar.tugboat.gtd.contents.task.entity.TaskToTask;
import org.seasar.tugboat.gtd.contents.task.service.TaskDetailService;
import org.seasar.tugboat.gtd.mailservices.service.MailService;

/**
 * task detail service implement.
 * 
 * @author yosuke
 * 
 */
public class TaskDetailServiceImpl implements TaskDetailService {
    /* LOGGER */
    Logger logger_ = Logger.getLogger(TaskDetailServiceImpl.class);

    /* task dxo */
    TaskDxo taskDxo_;

    public void setTaskDxo(TaskDxo taskDxo) {
        this.taskDxo_ = taskDxo;
    }

    /* tasks Dao */
    TasksDao tasksDao_;

    public void setTasksDao(TasksDao tasksDao) {
        this.tasksDao_ = tasksDao;
    }

    /* task relations dao */
    TaskRelationsDao taskRelationsDao_;

    public void setTaskRelationsDao(TaskRelationsDao taskRelationsDao) {
        this.taskRelationsDao_ = taskRelationsDao;
    }

    /* task body dao */
    TaskBodiesDao taskBodiesDao_;

    public void setTaskBodiesDao(TaskBodiesDao taskBodiesDao) {
        this.taskBodiesDao_ = taskBodiesDao;
    }

    /* task history Dao */
    TaskHistoriesDao taskHistoriesDao_;

    public void setTaskHistoriesDao(TaskHistoriesDao taskHistoriesDao) {
        this.taskHistoriesDao_ = taskHistoriesDao;
    }

    /* task to tasks dao */
    TaskToTasksDao taskToTasksDao_;

    public void setTaskToTasksDao(TaskToTasksDao taskToTasksDao) {
        this.taskToTasksDao_ = taskToTasksDao;
    }

    /* task comment dao */
    TaskCommentsDao taskCommentsDao_;

    public void setTaskCommentsDao(TaskCommentsDao taskCommentsDao) {
        this.taskCommentsDao_ = taskCommentsDao;
    }

    /* task comment body dao */
    TaskCommentBodiesDao taskCommentBodiesDao_;

    public void setTaskCommentBodiesDao(
            TaskCommentBodiesDao taskCommentBodiesDao) {
        this.taskCommentBodiesDao_ = taskCommentBodiesDao;
    }

    /* task comment relations dao */
    TaskCommentRelatiosDao taskCommentRelatiosDao_;

    public void setTaskCommentRelatiosDao(
            TaskCommentRelatiosDao taskCommentRelatiosDao) {
        taskCommentRelatiosDao_ = taskCommentRelatiosDao;
    }

    /* meeting to tasks dao */
    MeetingToTasksDao meetingToTasksDao_;
    
    public void setMeetingToTasksDao(MeetingToTasksDao meetingToTasksDao) {
        this.meetingToTasksDao_ = meetingToTasksDao;
    }
    
    /* search service */
    SearchService searchService_;

    public void setSearchService(SearchService searchService) {
        this.searchService_ = searchService;
    }

    /* mail service */
    MailService mailService_;

    public void setMailService(MailService mailService) {
        this.mailService_ = mailService;
    }
    
    /* activity dao */
    ActivitiesDao activitiesDao_;

    public void setActivitiesDao(ActivitiesDao activitiesDao) {
        this.activitiesDao_ = activitiesDao;
    }

    /* activity members dao */
    ActivityMembersDao activityMembersDao_;

    public void setActivityMembersDao(ActivityMembersDao activityMembersDao) {
        this.activityMembersDao_ = activityMembersDao;
    }

    /* activity dxo */
    ActivityDxo activityDxo_;

    public void setActivityDxo(ActivityDxo activityDxo) {
        this.activityDxo_ = activityDxo;
    }
    
    /* task tags dao */
    TaskTagsDao taskTagsDao_;

    public void setTaskTagsDao(TaskTagsDao taskTagsDao) {
        this.taskTagsDao_ = taskTagsDao;
    }

    /* tags dao */
    TagsDao tagsDao_;

    public void setTagsDao(TagsDao tagsDao) {
        this.tagsDao_ = tagsDao;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#addTaskComment(
     *      org.seasar.tugboat.gtd.contents.task.dto.TaskCommentDto,
     *      org.seasar.tugboat.gtd.contents.task.dto.TaskCommentBodyDto)
     */
    public TaskCommentDto[] addTaskComment(TaskCommentDto commentDto,
            TaskCommentBodyDto bodyDto) {
        int commentId = this.taskCommentsDao_.selectNewCommentId();

        TaskComment comment = this.taskDxo_.convertTaskComment(commentDto);
        comment.setId(commentId);
        this.taskCommentsDao_.insert(comment);

        TaskCommentBody body = this.taskDxo_.convertTaskCommentBody(bodyDto);
        body.setCommentId(commentId);
        this.taskCommentBodiesDao_.insert(body);

        // add search index.
        TaskCommentRelation commentRelation = 
            this.taskCommentRelatiosDao_.findByCommentId(commentId);

        this.searchService_.generateTaskCommentIndex(commentRelation);

        // get comments by task id.
        TaskComment[] taskComments = 
            this.taskCommentsDao_.findByTaskId(commentDto.getTaskId());

        // send mail
        this.sendMail(commentId, commentRelation.getTaskId());

        return this.taskDxo_.convertTaskCommentDtos(taskComments);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#addTaskToTasks(
     *      org.seasar.tugboat.gtd.contents.task.dto.TaskToTaskDto)
     */
    public void addTaskToTasks(TaskToTaskDto taskToTasksDto) {
        int taskId = this.tasksDao_.getNewTaskId().getId();
        taskToTasksDto.setDestinationTaskId(taskId);
        TaskToTask taskToTask = this.taskDxo_.convertTaskToTasks(taskToTasksDto);

        Task task = this.taskDxo_.convertFromTaskToTaskToTask(taskToTask);
        TaskBody body = this.taskDxo_.convertFromTaskToTaskToTaskBody(taskToTask);
        TaskRelation relations = this.taskDxo_.convertFromTaskToTaskToTaskRelations(taskToTask);
        TaskHistory history = this.taskDxo_.convertFromTaskToTaskToTaskHistory(taskToTask);

        // add task.
        this.tasksDao_.insert(task);
        this.taskRelationsDao_.insert(relations);
        this.taskBodiesDao_.insert(body);
        this.taskHistoriesDao_.insert(history);
        this.taskToTasksDao_.insert(taskToTask);
        
        // add task tags.
        List<Integer> tagIds = new ArrayList<Integer>();
        String[] tags = taskToTasksDto.getDestinationTags();
        if (tags != null && tags.length > 0) {
            for (int i = 0; i < tags.length; i++) {
                Tag tag = this.tagsDao_.findByValue(tags[i]);
                if (tag == null) {
                    this.tagsDao_.insert(tags[i]);
                    tag = this.tagsDao_.findByValue(tags[i]);
                }
                TaskTag taskTag = new TaskTag();
                taskTag.setTaskId(taskToTask.getDestinationTaskId());
                taskTag.setUserId(task.getUserId());
                taskTag.setTagId(tag.getId());
    
                tagIds.add(tag.getId());
    
                this.taskTagsDao_.insert(taskTag);
            }
    
            // share tags.
            ActivityMember[] members = 
                this.activityMembersDao_.selectByActivityId(task.getActivityId());
    
            for (ActivityMember m : members) {
                if (m.getUserId() == task.getUserId()) continue;
    
                for (Integer id : tagIds) {
                    TaskTag taskTag = new TaskTag();
                    taskTag.setTaskId(taskToTask.getDestinationTaskId());
                    taskTag.setUserId(m.getUserId());
                    taskTag.setTagId(id);
                    this.taskTagsDao_.insert(taskTag);
                }
            }
        }

        // add search indexes.
        TaskRelation relationsEntityForSearch = 
            this.taskRelationsDao_.findByTaskId(task.getId(), task.getUserId());

        this.searchService_.generateTaskIndex(relationsEntityForSearch);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#deleteTaskComment(
     *      org.seasar.tugboat.gtd.contents.task.dto.TaskCommentBodyDto)
     */
    public void deleteTaskComment(TaskCommentBodyDto bodyDto) {
        TaskCommentBody body = this.taskDxo_.convertTaskCommentBody(bodyDto);
        TaskCommentRelation commentRelation = 
            this.taskCommentRelatiosDao_.findByCommentId(body.getCommentId());
        
        commentRelation.setComment("");

        this.searchService_.generateTaskCommentIndex(commentRelation);
        this.taskCommentBodiesDao_.delete(body);

        // send mail
        this.sendMail(bodyDto.getCommentId(), bodyDto.getTaskId());
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#getTaskCommentByCommentId(int)
     */
    public TaskCommentDto getTaskCommentByCommentId(int commentId) {
        TaskComment comment = this.taskCommentsDao_.findById(commentId);
        return this.taskDxo_.convertTaskCommentDto(comment);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#getTaskCommentsByTaskId(int)
     */
    public TaskCommentDto[] getTaskCommentsByTaskId(int taskId) {
        TaskComment[] comments = this.taskCommentsDao_.findByTaskId(taskId);
        return this.taskDxo_.convertTaskCommentDtos(comments);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#getTaskToTasksByTaskId(int)
     */
    public TaskToTaskDto[] getTaskToTasksByTaskId(int taskId) {
        TaskToTask[] taskToTasks = this.taskToTasksDao_.findTaskToTasksByTaskId(taskId);
        return this.taskDxo_.convertTasktoTaskDtos(taskToTasks);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.seasar.tugboat.gtd.contents.task.service.TaskDetailService#updateTaskComment(
     *      org.seasar.tugboat.gtd.contents.task.dto.TaskCommentBodyDto)
     */
    public void updateTaskComment(TaskCommentBodyDto bodyDto) {
        TaskCommentBody body = this.taskDxo_.convertTaskCommentBody(bodyDto);
        this.taskCommentBodiesDao_.update(body);

        TaskCommentRelation commentRelation = 
            this.taskCommentRelatiosDao_.findByCommentId(body.getCommentId());

        // send mail
        this.sendMail(bodyDto.getCommentId(), bodyDto.getTaskId());

        this.searchService_.generateTaskCommentIndex(commentRelation);
    }
    
    /**
     * send mail. (common method)
     * 
     * @param commentId
     * @param taskId
     */
    void sendMail(int commentId, int taskId) {
        TaskCommentDto taskCommentDto = getTaskCommentByCommentId(commentId);
        int userId = taskCommentDto.getUserId();
        TaskCommentDto[] comments = getTaskCommentsByTaskId(taskId);

        this.taskRelationsDao_.findByTaskId(taskId, userId);
        TaskRelation task = this.taskRelationsDao_.findByTaskId(taskId, userId);
        TaskRelationDto taskDto = this.taskDxo_.convertTaskDtoWithoutDescription(task);

        Activity activity = 
            this.activitiesDao_.selectActivityById(task.getActivityId());
        ActivityMember[] members = 
            this.activityMembersDao_.findActivityMembersByActivityId(task.getActivityId());

        ActivityDto activityDto = 
            this.activityDxo_.convertActivityDto(activity, members);

        this.mailService_.sendMail(taskDto, comments, activityDto, userId);
    }

}
