/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package org.seasar.tugboat.gtd.contents.timeline.entity.xml;

import org.xml.sax.*;

/**
 * @version xmlTimeline.rng 1.0 (Mon Dec 18 18:35:28 JST 2006)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public class XmlTimelineBaseHandler implements IRContentClassHandler {
    private Data data_;

    /**
     * Gets aData.
     *
     * @return Data
     */
    public Data getData() {
        return (data_);
    }

    /**
     * Event handler for initElement during object construction.
     *
     * @param attrs
     */
    public void initElement(Attributes attrs) {
    }

    /**
     * Event handler for declarePrefixMapping during object construction.
     *
     * @param prefix
     * @param uri
     */
    public void declarePrefixMapping(String prefix, String uri) {
    }

    /**
     * Event handler for startElement during object construction.
     *
     * @param namespaceURI
     * @param localName
     * @param qName
     * @param attrs
     * @return IRContentClassHandler
     */
    public IRContentClassHandler startElement(String namespaceURI, String localName, String qName, Attributes attrs) {
        if ("data".equals(qName)) {
            data_ = new Data();
            data_.initElement(attrs);
            return (data_);
        }
        return (this);
    }

    /**
     * Event handler for endElement during object construction.
     *
     * @param namespaceURI
     * @param localName
     * @param qName
     * @return IRContentClassHandler
     */
    public IRContentClassHandler endElement(String namespaceURI, String localName, String qName) {
        return (this);
    }

    /**
     * Event handler for characters during object construction.
     *
     * @param ch
     * @param start
     * @param length
     */
    public void characters(char[] ch, int start, int length) {
    }

    /**
     * Event handler for processngInstruction during object construction.
     *
     * @param target
     * @param value
     */
    public void processingInstruction(String target, String value) {
    }
}
