/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.dto;

import java.io.Serializable;

/**
 * UserAdminMessage for xls file
 * @author r-ishizuka
 *
 */
public class UserAdminMessageDto implements Serializable{
    static final long serialVersionUID = 1L;
    
    public static final int FORMAT = 1;
    public static final int EXIST = 2;

    /* line */
    int line_ = -1;
    
    public int getLine() {
        return line_;
    }
    public void setLine(int line) {
        this.line_ = line;
    }

    /* code */
    int code_;
    
    public int getCode() {
        return code_;
    }
    public void setCode(int code) {
        this.code_ = code;
    }

    /* user */
    String user_;
    
    public String getUser() {
        return user_;
    }
    public void setUser(String user) {
        this.user_ = user;
    }
    
    /*
     * (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        String message;
        switch (code_) {
        case FORMAT:
            message = "xls file's format is wrong.";
            break;
        case EXIST:
            message = "User id: " + user_ + " is already exist.";
            break;
        default:
            message = "Unknow Error";
        }
        if (line_ != -1) {
            message += " [line=" + line_ + "]";
        }
        return message;
    }
}
