/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * User Entity
 * 
 * @author yousuke.hara
 * 
 */
@Bean(table = "users")
public class User implements Serializable {
    static final long serialVersionUID = 1L;

    public User() {
        super();
    }

    /* User Id */
    int userId_;

    @Column("ID")
    public int getUserId() {
        return userId_;
    }

    public void setUserId(int userId) {
        this.userId_ = userId;
    }

    /* Login Id */
    String loginId_;

    @Column("LOGIN_ID")
    public String getLoginId() {
        return loginId_;
    }

    public void setLoginId(String loginId) {
        this.loginId_ = loginId;
    }

    /* Email */
    String email_;

    @Column("EMAIL")
    public String getEmail() {
        return email_;
    }

    public void setEmail(String email) {
        this.email_ = email;
    }

    /* First Name */
    String firstName_;

    @Column("FIRST_NAME")
    public String getFirstName() {
        return firstName_;
    }

    public void setFirstName(String firstName) {
        this.firstName_ = firstName;
    }

    /* Last Name */
    String lastName_;

    @Column("LAST_NAME")
    public String getLastName() {
        return lastName_;
    }

    public void setLastName(String lastName) {
        this.lastName_ = lastName;
    }

    /* Password */
    String password_;

    @Column("PASSWORD")
    public String getPassword() {
        return password_;
    }

    public void setPassword(String password) {
        this.password_ = password;
    }

    /* Photo Image URL */
    String photoImageUrl_;

    @Column("PHOTO_IMG_URL")
    public String getPhotoImageUrl() {
        return photoImageUrl_;
    }

    public void setPhotoImageUrl(String photoImageUrl) {
        this.photoImageUrl_ = photoImageUrl;
    }
    
    /* Modified User ID */
    int modifiedUserId_;
    
    @Column("MODIFIED_USER_ID")
    public int getModifiedUserId() {
        return modifiedUserId_;
    }
    
    public void setModifiedUserId(int modifiedUserId) {
        this.modifiedUserId_ = modifiedUserId;
    }

    /* role id */
    int roleId_;
    
    @Column("ROLE_ID")
    public int getRoleId() {
        return roleId_;
    }
    public void setRoleId(int roleId) {
        this.roleId_ = roleId;
    }
    
    /* role name */
    String roleName_;
    
    @Column("ROLE_NAME")
    public String getRoleName() {
        return roleName_;
    }
    public void setRoleName(String roleName) {
        this.roleName_ = roleName;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
