/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.contents.user.page;

/**
 * user admin ajax.
 *
 */
public interface UserAdminAjax {
    /**
     * add User
     * 
     * @return UserDto JSON. if user already exist, return ''.
     */
    String add();
    
    /**
     * list User
     * @return UserDto[]'s JSON
     */
    String list();
    
    /**
     * delete User
     * @return delet
     */
    String delete();
    
    /**
     * update User
     * @return updated UserDto's JSON. if invalid email, return "email". 
     */
    String update();
    
    /**
     * get user count
     * @return
     */
    String getCount();
}
