/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.entity;

import java.io.Serializable;

import org.apache.commons.lang.builder.ReflectionToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.seasar.dao.annotation.tiger.Bean;
import org.seasar.dao.annotation.tiger.Column;

/**
 * feed token.
 * 
 * @author yosuke
 *
 */
@Bean(table = "feed_tokens")
public class FeedToken implements Serializable {
    static final long serialVersionUID = 1L;
    
    /* id */
    int id_;
    
    @Column("ID")
    public int getId() {
        return id_;
    }
    public void setId(int id) {
        this.id_ = id;
    }
    
    /* token */
    String token_;
    
    @Column("TOKEN")
    public String getToken() {
        return token_;
    }
    public void setToken(String token) {
        this.token_ = token;
    }
    
    /* user id */
    int userId_;
    
    @Column("USER_ID")
    public int getUserId() {
        return userId_;
    }
    public void setUserId(int userId) {
        this.userId_ = userId;
    }
    
    /* activity id */
    int activityId_;
    
    @Column("ACTIVITY_ID")
    public int getActivityId() {
        return activityId_;
    }
    public void setActivityId(int activityId) {
        this.activityId_ = activityId;
    }
    
    /* created at */
    String createdAt_;
    
    @Column("CREATED_AT")
    public String getCreatedAt() {
        return createdAt_;
    }
    public void setCreatedAt(String createdAt) {
        this.createdAt_ = createdAt;
    }
    
    /* delete flag */
    String deleteFlag_;
    
    @Column("DEL_FLAG")
    public String getDeleteFlag() {
        return deleteFlag_;
    }
    public void setDeleteFlag(String deleteFlag) {
        this.deleteFlag_ = deleteFlag;
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return ReflectionToStringBuilder.toString(this,
                ToStringStyle.MULTI_LINE_STYLE);
    }
}
