/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.feeds.atom;

import org.seasar.tugboat.gtd.contents.task.dto.TaskTagDto;

import com.sun.syndication.feed.module.Module;

/**
 * task item module.
 * 
 * @author yosuke
 *
 */
public interface TaskDetailItemModule extends Module {
    public static final String URI = "http://tugboat-gtd.seasar.org/module";
    public static final String NS_TUGBOAT = "tgb";
    
    public static final String ELEMENT_DETAIL = "detail";
    public static final String ELEMENT_ACTIVITY = "activity";
    public static final String ELEMENT_CLASSIFICATION = "classification";
    public static final String ELEMENT_STATUS = "status";
    public static final String ELEMENT_PERSON_IN_CHARGE = "person_in_charge";
    public static final String ELEMENT_TAG = "tag";
    
    public static final String ATRB_ID  = "id";
    public static final String ATRB_NAME = "name";
    public static final String ATRB_COLOR = "color";
    public static final String ATRB_FIRST_NAME = "first_name";
    public static final String ATRB_LAST_NAME = "last_name";
    
    /* status id*/
    public int getStatusId();
    public void setStatusId(int statusId);
    
    /* activity id */
    public int getActivityId();
    public void setActivityId(int activityId);
    
    /* activity name */
    public String getActivityName();
    public void setActivityName(String activityName);
    
    /* activity color */
    public String getActivityColor();
    public void setActivityColor(String activityColor);
    
    /* classification id */
    public int getClassificationId();
    public void setClassificationId(int classificationId);
    
    /* person in charge id */
    public int getPersonInChargeId();
    public void setPersonInChargeId(int personInChargeId);
    
    /* person in charge first name */
    public String getPersonInChargeFirstName();
    public void setPersonInChargeFirstName(String personInChargeFirstName);
    
    /* preson in charge last name */
    public String getPersonInChargeLastName();
    public void setPersonInChargeLastName(String personInChargeLastName);
    
    /* tags */
    public TaskTagDto[] getTags();
    public void setTags(TaskTagDto[] tags);
}
