/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.feeds.atom;

import org.jdom.Element;
import org.jdom.Namespace;

import com.sun.syndication.feed.module.Module;
import com.sun.syndication.io.ModuleParser;

/**
 * task security feed module parser implement.
 * 
 * @author yosuke
 * 
 */
public class TaskHeaderFeedModuleParserImpl implements ModuleParser {

    /*
     * (non-Javadoc)
     * @see com.sun.syndication.io.ModuleParser#getNamespaceUri()
     */
    public String getNamespaceUri() {
        return TaskHeaderFeedModule.URI;
    }

    /*
     * (non-Javadoc)
     * @see com.sun.syndication.io.ModuleParser#parse(org.jdom.Element)
     */
    public Module parse(Element element) {
        Namespace ns = Namespace.getNamespace(TaskHeaderFeedModule.URI);
        TaskHeaderFeedModule module = new TaskHeaderFeedModuleImpl();
        Element user = element.getChild(TaskHeaderFeedModule.ELEMENT_USER, ns);
        if (user != null) {
            Element userIdElement = user.getChild(TaskHeaderFeedModule.ELEMENT_CREATED, ns);
            module.setCreated(userIdElement.getText());
            
            Element nounceElement = user.getChild(TaskHeaderFeedModule.ELEMENT_NOUNCE, ns);
            module.setNonce(nounceElement.getText());
        }
        return module;
    }

}
