package org.seasar.tugboat.gtd.webservices.service;

import org.seasar.tugboat.gtd.webservices.entity.FeedToken;

/**
 * feed token service.
 * 
 * @author yosuke
 *
 */
public interface FeedTokenService {

    /**
     * create.
     * 
     * @param activityId
     * @param userId
     * @return - feed token.
     */
    String create(int activityId, int userId);
    
    /**
     * reset.
     * 
     * @param activity
     * @param userId
     * @return - feed token.
     */
    String reset(int activityId, int userId);
    
    /**
     * delete activity id and user id.
     * 
     * @param activityId
     * @param userId
     * @return
     */
    void deleteByActivityIdAndUserId(int activityId, int userId);
    
    /**
     * delete by activity id.
     * 
     * @param activityId
     */
    void deleteByActivityId(int activityId);
    
    /**
     * find by activity id and token.
     * 
     * @param activityId
     * @param token
     * @return
     */
    FeedToken findByActivityIdAndToken(int activityId, String token);
}
