/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.service.impl;

import org.seasar.tugboat.gtd.container.annotation.RestMethod;
import org.seasar.tugboat.gtd.container.constant.HttpMethod;
import org.seasar.tugboat.gtd.contents.activity.dto.ActivityMemberDto;
import org.seasar.tugboat.gtd.contents.activity.service.ActivityMembersService;
import org.seasar.tugboat.gtd.webservices.helper.WebServiceHelper;
import org.seasar.tugboat.gtd.webservices.service.ActivityMemberWebService;
import org.seasar.tugboat.gtd.webservices.service.DefaultRESTfulWebService;

/**
 * activity member web service implements.
 * 
 * @author yosuke
 *
 */
public class ActivityMemberRESTWebServiceImpl extends DefaultRESTfulWebService implements ActivityMemberWebService {

    /* id */
    int id_;
    public void setId(int id) {
        this.id_ = id;
    }
    
    /* activity ids */
    Integer[] activityIds_;
    public void setActivityIds(Integer[] activityIds) {
        this.activityIds_ = activityIds;
    }
    
    /* activity member service */
    ActivityMembersService activityMemberService_;
    public void setActivityMemberService(ActivityMembersService activityMemberService) {
        this.activityMemberService_ = activityMemberService;
    }
    
    /* web service helper */
    WebServiceHelper webServiceHelper_;
    public void setWebServiceHelper(WebServiceHelper webServiceHelper) {
        this.webServiceHelper_ = webServiceHelper;
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.webservices.service.ActivityMemberWebService#findByActivities()
     */
    @RestMethod(methods = HttpMethod.GET, parameters = "activityIds")
    public String findByActivities() {
    	ActivityMemberDto[] members = 
            this.activityMemberService_.getActivityMembersByActivities(this.activityIds_);
        return this.webServiceHelper_.createActivityMembers(this.acceptType_, members);
    }

    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.webservices.service.ActivityMemberWebService#findByBelongActivities()
     */
    @RestMethod(methods = HttpMethod.GET)
    public String findByBelongActivities() {
        ActivityMemberDto[] members = 
            this.activityMemberService_.getMembersListRelatedToUser(this.userId_);
        
        return this.webServiceHelper_.createActivityMembers(this.acceptType_, members);
    }

}
