/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.tugboat.gtd.webservices.service.impl;

import org.seasar.tugboat.gtd.container.annotation.RestMethod;
import org.seasar.tugboat.gtd.container.constant.HttpMethod;
import org.seasar.tugboat.gtd.contents.activity.dto.ActivityDto;
import org.seasar.tugboat.gtd.contents.activity.service.ActivityMembersService;
import org.seasar.tugboat.gtd.contents.activity.service.ActivityService;
import org.seasar.tugboat.gtd.webservices.helper.WebServiceHelper;
import org.seasar.tugboat.gtd.webservices.service.ActivityWebService;
import org.seasar.tugboat.gtd.webservices.service.DefaultRESTfulWebService;

/**
 * activity rest web service implement.
 * 
 * @author yosuke
 *
 */
public class ActivityRESTWebServiceImpl extends DefaultRESTfulWebService implements ActivityWebService {

    /* id */
    int id_;
    public void setId(int id) {
        this.id_ = id;
    }
    
    /* activity service */
    ActivityService activityService_;
    public void setActivityService(ActivityService activityService) {
        this.activityService_ = activityService;
    }
    
    /* activity member service */
    ActivityMembersService activityMemberService_;
    public void setActivityMembersService(ActivityMembersService activityMemberService) {
        this.activityMemberService_ = activityMemberService;
    }
    
    /* web service helper */
    WebServiceHelper webServiceHelper_;
    public void setWebServiceHelper(WebServiceHelper webServiceHelper) {
        this.webServiceHelper_ = webServiceHelper;
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.webservices.service.ActivityWebService#findById()
     */
    @RestMethod(methods = HttpMethod.GET, parameters = "id")
    public String findById() {
        return null;
    }

    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.webservices.service.ActivityWebService#getOwnActivities()
     */
    @RestMethod(methods = HttpMethod.GET)
    public String getOwnActivities() {
        ActivityDto[]  activities = this.activityService_.getOwnActivities(this.userId_);
        
        return webServiceHelper_.createActities(this.acceptType_, activities);
    }

}
