package org.seasar.tugboat.gtd.webservices.service.impl;

import java.util.Date;

import org.apache.commons.lang.RandomStringUtils;
import org.apache.commons.lang.time.DateFormatUtils;
import org.seasar.tugboat.gtd.webservices.dao.FeedTokensDao;
import org.seasar.tugboat.gtd.webservices.entity.FeedToken;
import org.seasar.tugboat.gtd.webservices.service.FeedTokenService;

/**
 * feed token service implement.
 * 
 * @author yosuke
 *
 */
public class FeedTokenServiceImpl implements FeedTokenService {

    /* feed tokens dao */
    FeedTokensDao feedTokensDao_;
    
    public void setFeedTokensDao(FeedTokensDao feedTokensDao) {
        this.feedTokensDao_ = feedTokensDao;
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.feeds.common.service.FeedTokenService#create(int, int)
     */
    public String create(int activityId, int userId) {
        String token = RandomStringUtils.randomAlphabetic(20);
        FeedToken result = this.feedTokensDao_.findByActivityIdAndToken(activityId, token);
        if (result != null && !"".equals(result.getToken())) {
            this.create(activityId, userId);
        }
        
        FeedToken feedToken = new FeedToken();
        feedToken.setUserId(userId);
        feedToken.setActivityId(activityId);
        feedToken.setToken(token);
        feedToken.setCreatedAt(DateFormatUtils.format(new Date(), "yyyyMMddHHmmss"));
        this.feedTokensDao_.insert(feedToken);
        return token;
    }


    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.feeds.common.service.FeedTokenService#reset(int, int)
     */
    public String reset(int activityId, int userId) {
        FeedToken feedToken = new FeedToken();
        feedToken.setUserId(userId);
        feedToken.setActivityId(activityId);
        this.feedTokensDao_.updateDeleteFlagByActivityIdAndUserId(feedToken);
        
        return this.create(activityId, userId);
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.feeds.common.service.FeedTokenService#delete(int, int)
     */
    public void deleteByActivityIdAndUserId(int activityId, int userId) {
        FeedToken feedToken = new FeedToken();
        feedToken.setActivityId(activityId);
        feedToken.setUserId(userId);
        this.feedTokensDao_.updateDeleteFlagByActivityIdAndUserId(feedToken);
    }
    
    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.feeds.common.service.FeedTokenService#deleteByActivityId(int)
     */
    public void deleteByActivityId(int activityId) {
        this.feedTokensDao_.updateDeleteFlagByActivityId(activityId);
    }

    /*
     * (non-Javadoc)
     * @see org.seasar.tugboat.gtd.feeds.common.service.FeedTokenService#findByActivityIdAndToken(int, java.lang.String)
     */
    public FeedToken findByActivityIdAndToken(int activityId, String token) {
        return this.feedTokensDao_.findByActivityIdAndToken(activityId, token);
    }
}
