/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
if (typeof(Tugboat.gtd_user) == 'undefined') {
    Tugboat.gtd_user = {};
}

Tugboat.gtd_user = {
  _is_change_password:false,
  _user_info: null,
  
  /**
   * initialize.
   */
  init : function () {
    var self = Tugboat.gtd_user;
    self._setup_event_rules();
	
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters:{
          component:'userAjax',
          action   :'get'
        },
        onComplete: function(transport){
          var self = Tugboat.gtd_user;
          self._user_info = eval('(' +transport.responseText+')');
          self.reset();
        }
      }
    );
  },
  
  /**
   * setup event rules.
   *
   */
  _setup_event_rules : function() {
    var self = Tugboat.gtd_user;
    var rules = {
      '#menuBar_modifyUser' : function(el) {
        el.onclick = function() {
          self.modify_user_onclick();
          el.blur();
          return false;
        }
      },
      '#modify_user_cancel': function(el) {
        el.onclick = function() {
          Windows.closeAll();
          self.modal.close();
          el.blur();
          return false;
        }
      },
      '#modify_user_post': function(el) {
        el.onclick = function() {
          self.post_onclick();
          return false;
        }
      },      'span.user_view': function(el) {
        el.onmouseover = function() {
          el.style.backgroundColor = '#ffa';
          el.style.cursor = 'cursor';
        };
        el.onmouseout = function() {
          el.style.backgroundColor = '#fff';
          el.style.cursor = 'default';
        };
      },
      '#user_view_firstName': function(el) {
        el.onclick = function() {
          $('user_view_firstName').hide();
          $('user_edit_firstName').show();
        }
      },
      '#user_view_lastName': function(el) {
        el.onclick = function() {
          $('user_view_lastName').hide();
          $('user_edit_lastName').show();
        }
      },
      '#user_view_email': function(el) {
        el.onclick = function() {
          $('user_view_email').hide();
          $('user_edit_email').show();
        }
      },
      '#user_view_password': function(el) {
        el.onclick = function() {
          $('user_view_password').hide();
          $('user_edit_password').show();
          $('user_edit_passwordConfirm').show();
          self._is_change_password = true;
        }
      }
    };
    Behaviour.register(rules);
  },
  
	/**
	 * modify user on click.
	 *
	 */
  modify_user_onclick: function() {
    var self = Tugboat.gtd_user;
    
    self.reset();
    self.user_modify_window = 
      new Window(
        'userModifyWindow', 
        { className: 'mac_os_x', width:350, height:230, 
          zIndex: 100, 
          minimizable: false, 
          closable   : false, 
          maximizable: false,
          resizable  : false, 
          draggable  : true,
          title      : 'Modify user',
          showEffectOptions:{
            duration:0.3, 
            afterFinish:function(){$('modify_user_post').focus();}
          }
        }
      );
    self.user_modify_window.setContent('user_sub_window_container',false,false);
    self.user_modify_window.setDestroyOnClose();
    self.user_modify_window.showCenter();
    self.modal.open();
    
    var userWindowObserver = {
      onDestroy: function(eventName, win) {
        if (win == self.user_modify_window) {
          Windows.removeObserver(this);
          Tugboat.gtd_user.modal.close();
        }
      }
    };
    Windows.addObserver(userWindowObserver);
  },
  
  /**
   * post on click.
   */
  post_onclick: function() {
    var self = Tugboat.gtd_user;
    var _user = {
      email         : $F('user_edit_email'),
			first_name    : $F('user_edit_firstName'),
			last_name     : $F('user_edit_lastName'),
			password      : $F('user_edit_password'),
			password_conf : $F('user_edit_passwordConfirm')
    }

    /*validate*/
		var messages = [];
    if (_user.email == '') {
      messages.put('Email is required.');
    } 
    else if(_user.first_name == '') {
			messages.put('First Name is required.');
    } 
    else if(_user.last_name == '') {
			messages.put('Last Name is required.');
    }
    if(self._is_change_password) {
      if (_user.password != _user.password_conf) {
        messages.put('Password is not match.');
      }
      else if(_user.password == '') {
        messages.put('Password is required.');
      }
    }
		if (messages) {
      Tugboat.showAlertDialog(messages);
      return false;
		}

    var parameters = {
      component: 'userAjax',
      action:    'update',
      userId:    self._user_info.userId,
      email:     _user.email,
      firstName: _user.first_name,
      lastName:  _user.last_name
    };
    if (self._is_change_password) {
        parameters['password']   = _user.password;
    }
    new Ajax.Request(
      Tugboat.AJAX_SERVLET_NAME,
      {
        method: Tugboat.constant.REQUEST_GET,
        parameters: parameters,
        onComplete: function(transport){
          if(transport.responseText == 'email') {
            alert('invalid email');
            $('user_edit_email').focus();
            return false;
          }
          var self = Tugboat.gtd_user;
          self._user_info = eval('(' +transport.responseText+')');
          $('modify_user_post').blur();
          Windows.closeAll();
          self.modal.close();
        }
      }
    );          
  },
	
	/**
	 * reset.
	 *
	 */
  reset: function(){
    var self = Tugboat.gtd_user;
		
		// TODO
    $$('span.user_view').each(function(span){
      span.show();
    });
    $$('.user_edit').each(function(span){
      span.hide();
    });
    $('user_view_loginId').innerHTML     = self._user_info.loginId;
    $('user_view_email').innerHTML       = self._user_info.email;
    $('user_edit_email').value           = self._user_info.email;
    $('user_view_firstName').innerHTML   = self._user_info.firstName;
    $('user_edit_firstName').value       = self._user_info.firstName;
    $('user_view_lastName').innerHTML    = self._user_info.lastName;
    $('user_edit_lastName').value        = self._user_info.lastName;
    $('user_edit_password').value        = '';
    $('user_edit_passwordConfirm').value = '';
  },
  
  /*
   * Modal window
   *
   * 
   */
  modal : {
    open : function () {
      var page = Tugboat.getPageSize(); 
      Element.setHeight('modal_window', page.pageHeight);
      $('modal_window').style.display = 'block';
    },

    close : function() {
      $('modal_window').style.display = 'none';
    }
  }
};
