package org.seasar.tugboat.gtd.contents.meeting.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgendaDiscussion;

/**
 * test meeting agenda discussions dao.
 * 
 * @author yosuke
 * 
 */
public class TestMeetingAgendaDiscussionsDao extends S2DaoTestCase {
    MeetingAgendaDiscussionsDao meetingAgendaDiscussionsDao_;
    
    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/meeting/meetingDao.dicon");
    }

    
    /**
     * test #insert.
     *
     */
    public void testInsertTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgendaDiscussion entity = 
            this.meetingAgendaDiscussionsDao_.findNewId();
        
        MeetingAgendaDiscussion discussion = new MeetingAgendaDiscussion();
        discussion.setId(entity.getId());
        discussion.setAgendaId(9990);
        discussion.setType("1");
        discussion.setPostedUserId(9990);
        discussion.setModifiedUserId(9990);
        
        int result = this.meetingAgendaDiscussionsDao_.insert(discussion);
        super.assertEquals(1, result);
    }
    
    /**
     * test #update.
     *
     */
    public void testUpdateTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgendaDiscussion entity = 
            this.meetingAgendaDiscussionsDao_.findNewId();
        
        MeetingAgendaDiscussion discussion = new MeetingAgendaDiscussion();
        discussion.setId(entity.getId());
        discussion.setAgendaId(9990);
        discussion.setType("1");
        discussion.setPostedUserId(9990);
        discussion.setModifiedUserId(9990);
        
        int result = this.meetingAgendaDiscussionsDao_.insert(discussion);
        super.assertEquals(1, result);
        
        discussion.setPostedUserId(9991);
        discussion.setModifiedUserId(9991);
        result = this.meetingAgendaDiscussionsDao_.update(discussion);
        super.assertEquals(1, result);
    }
    
    /**
     * test #updateDelFlag.
     *
     */
    public void testUpdateDelFlagTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        MeetingAgendaDiscussion entity = 
            this.meetingAgendaDiscussionsDao_.findNewId();
        
        MeetingAgendaDiscussion discussion = new MeetingAgendaDiscussion();
        discussion.setId(entity.getId());
        discussion.setAgendaId(9990);
        discussion.setType("1");
        discussion.setPostedUserId(9990);
        discussion.setModifiedUserId(9990);
        
        int result = this.meetingAgendaDiscussionsDao_.insert(discussion);
        super.assertEquals(1, result);
        
        result = 
            this.meetingAgendaDiscussionsDao_.updateDelFlag(discussion);
        super.assertEquals(1, result);
    }
    
    /**
     * test #findNewId.
     *
     */
    public void testFindNewIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        MeetingAgendaDiscussion entity = 
            this.meetingAgendaDiscussionsDao_.findNewId();
        
        super.assertEquals(10000, entity.getId());
    }
    
    /**
     * test #findByUserIdForTimeline.
     *
     */
    public void testFindByUserIdForTimelineTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgendaDiscussion[] entities = 
            this.meetingAgendaDiscussionsDao_.findByUserIdForTimeline(9990);
        
        super.assertEquals(5, entities.length);
    }
    
    /**
     * test #findDiscussionRelationById.
     *
     */
    public void testFindDiscussionRelationByIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgendaDiscussion entity = 
            this.meetingAgendaDiscussionsDao_.findDiscussionRelationById(9990);
        
        System.out.println(entity);
        
        super.assertEquals(9990, entity.getId());
        super.assertEquals(9990, entity.getAgendaId());
        super.assertEquals(true, "1".equals(entity.getType()));
        super.assertEquals(
            true, "meeting agenda discussion body 1".equals(entity.getBody()));
        
    }
}
