package org.seasar.tugboat.gtd.contents.meeting.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingAgenda;

/**
 * test meeting agendas Dao.
 * 
 * @author yosuke
 * 
 */
public class TestMeetingAgendasDao extends S2DaoTestCase {
    MeetingAgendasDao meetingAgendasDao_;

    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/meeting/meetingDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda entity = 
            this.meetingAgendasDao_.findNewId();
        
        MeetingAgenda agenda = new MeetingAgenda();
        agenda.setId(entity.getId());
        agenda.setPriority("1");
        agenda.setPostedUserId(9990);
        agenda.setModifiedUserId(9990);
        
        int result = this.meetingAgendasDao_.insert(agenda);
        super.assertEquals(1, result);
    }

    /**
     * test #update.
     * 
     */
    public void testUpdateTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda entity = 
            this.meetingAgendasDao_.findNewId();
        
        MeetingAgenda agenda = new MeetingAgenda();
        agenda.setId(entity.getId());
        agenda.setPriority("1");
        agenda.setPostedUserId(9990);
        agenda.setModifiedUserId(9990);
        int result = this.meetingAgendasDao_.insert(agenda);
        
        agenda.setPriority("2");
        agenda.setPostedUserId(9991);
        result = this.meetingAgendasDao_.update(agenda);
        
        super.assertEquals(1, result);
    }

    /**
     * test #updateDelFlag.
     * 
     */
    public void testUpdateDelFlagTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda entity = 
            this.meetingAgendasDao_.findNewId();
        
        MeetingAgenda agenda = new MeetingAgenda();
        agenda.setId(entity.getId());
        agenda.setPriority("1");
        agenda.setPostedUserId(9990);
        agenda.setModifiedUserId(9990);
        int result = this.meetingAgendasDao_.insert(agenda);
        
        result = this.meetingAgendasDao_.updateDelFlag(agenda);
        super.assertEquals(1, result);
    }

    /**
     * test #findNewId.
     * 
     */
    public void testFindNewIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda entity = 
            this.meetingAgendasDao_.findNewId();
        super.assertEquals(10000, entity.getId());
    }

    /**
     * test #findWithDiscussionByBasicId.
     * 
     */
    public void testFindWithDiscussionByBasicIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
       
        MeetingAgenda[] entities = 
            this.meetingAgendasDao_.findWithDiscussionByMeetingId(9990);
        
        super.assertEquals(3, entities.length);
    }

    /**
     * test #findByUserIdForTimeline.
     * 
     */
    public void testFindByUserIdForTimelineTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda[] entities = 
            this.meetingAgendasDao_.findByUserIdForTimeline(9990);
        
        super.assertEquals(10, entities.length);
    }

    /**
     * test #findAgendaRelationById.
     * 
     */
    public void testFindAgendaRelationByIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingAgenda entity = 
            this.meetingAgendasDao_.findAgendaRelationById(9990);
        
        super.assertEquals(9990, entity.getId());
        super.assertEquals(9990, entity.getPostedUserId());
        super.assertEquals(9990, entity.getActivityId());
        super.assertEquals(true, "meeting agenda body 1".equals(entity.getBody()));
    }
}
