package org.seasar.tugboat.gtd.contents.meeting.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingBrowsePageCondition;
import org.seasar.tugboat.gtd.contents.meeting.entity.MeetingToTask;

/**
 * test meeting to tasks dao.
 * 
 * @author yosuke
 *
 */
public class TestMeetingToTasks extends S2DaoTestCase {
    MeetingToTasksDao meetingToTasksDao_;
    
    /*
     * (non-Javadoc)
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/meeting/meetingDao.dicon");
    }
    
    /**
     * test #findTasksByBasicId.
     *
     */
    public void testFindTasksByBasicIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingBrowsePageCondition condition = new MeetingBrowsePageCondition();
        condition.setOffset(0);
        condition.setLimit(20);
        condition.setBasicId(9990);
        MeetingToTask[] entities = 
            this.meetingToTasksDao_.findTasksByBasicId(condition);
        
        super.assertEquals(1, entities.length);
    }
    
    /**
     * test #findTasksByAgendaId.
     *
     */
    public void testFindTasksByAgendaIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingToTask[] entities = 
            this.meetingToTasksDao_.findTasksByAgendaId(9991);
        
        super.assertEquals(1, entities.length);
    }
    
    /**
     * test #findTaskCountByBasicId.
     *
     */
    public void testFindTaskCountByBasicIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingToTask entity = 
            this.meetingToTasksDao_.findTaskCountByBasicId(9990);
        
        super.assertEquals(1, entity.getRowCount());
    }
    
    /**
     * test #insert.
     *
     */
    public void testInsertTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        MeetingToTask toTask = new MeetingToTask();
        toTask.setBasicId(9990);
        toTask.setAgendaId(9990);
        toTask.setDiscussionId(9990);
        toTask.setTaskId(9990);
        int result = this.meetingToTasksDao_.insert(toTask);
        super.assertEquals(1, result);
    }
    
    /**
     * test #findByTaskId.
     *
     */
    public void testFindByTaskIdTx() {
        super.readXlsWriteDb("meeting_basics.xls");
        
        MeetingToTask[] meetingToTasks = 
            this.meetingToTasksDao_.findByTaskId(9991);
        
        System.out.println(meetingToTasks.length);
    }
}
