package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskSelectTag;

/**
 * test TaskSelectTagsDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskSelectTagsDao extends S2DaoTestCase {
    TaskSelectTagsDao taskSelectTagsDao_;
    
    /*
     * (non-Javadoc)
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }
    
    /**
     * test #insert.
     *
     */
    public void testInsertTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");
        
        TaskSelectTag entity = new TaskSelectTag();
        entity.setTagId(9990);
        entity.setUserId(9990);
        int result = this.taskSelectTagsDao_.insert(entity);
        
        super.assertEquals("[OK]", 1, result);
    }
    
    /**
     * test #delete.
     *
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");
        
        TaskSelectTag entity = new TaskSelectTag();
        entity.setTagId(9990);
        entity.setUserId(9990);
        this.taskSelectTagsDao_.insert(entity);
        
        int result = this.taskSelectTagsDao_.delete(entity);
        super.assertEquals("[OK]", 1, result);
    }
    
    /**
     * test #findByUserId.
     *
     */
    public void testFindByUserIdTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");
        
        TaskSelectTag entity = new TaskSelectTag();
        entity.setTagId(9990);
        entity.setUserId(9990);
        this.taskSelectTagsDao_.insert(entity);
        
        entity = new TaskSelectTag();
        entity.setTagId(9991);
        entity.setUserId(9990);
        this.taskSelectTagsDao_.insert(entity);
        
        entity = new TaskSelectTag();
        entity.setTagId(9993);
        entity.setUserId(9990);
        this.taskSelectTagsDao_.insert(entity);
        
        TaskSelectTag[] result = 
            this.taskSelectTagsDao_.findByUserId(9990);
        super.assertEquals("[OK]", 3, result.length);
    }
}
