package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskTag;

/**
 * test TaskTagsDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskTagsDao extends S2DaoTestCase {
    TaskTagsDao taskTagsDao_;

    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag entity = new TaskTag();
        entity.setTaskId(9990);
        entity.setTagId(9990);
        entity.setUserId(9990);

        int result = this.taskTagsDao_.insert(entity);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #delete
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag entity = new TaskTag();
        entity.setTaskId(9990);
        entity.setTagId(9990);
        entity.setUserId(9990);
        this.taskTagsDao_.insert(entity);

        int result = this.taskTagsDao_.delete(entity.getTaskId());
        super.assertEquals("[OK]", 4, result);
    }

    /**
     * test #findByUserId.
     * 
     */
    public void testFindByUserIdTx() {
        super.readXlsWriteDb("taskBrowseRelated.xls");

        TaskTag[] result = this.taskTagsDao_.findByUserId(9990);
        super.assertEquals("[OK]", 10, result.length);
    }

    /**
     * test #findByTaskIdAndUserId.
     * 
     */
    public void testFindByTaskIdAndUserIdTx() {
         super.readXlsWriteDb("taskBrowseRelated.xls");
         
         TaskTag[] result = 
             this.taskTagsDao_.findByTaskIdAndUserId(9990, 9990);
         super.assertEquals("[OK]", 3, result.length);
    }
}
