package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.TaskToTask;

/**
 * test TaskToTasksDao.
 * 
 * @author yosuke
 * 
 */
public class TestTaskToTasksDao extends S2DaoTestCase {
    TaskToTasksDao taskToTasksDao_;

    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }

    /**
     * test #insert.
     * 
     */
    public void testInsertTx() {
        super.readXlsWriteDb("tasks.xls");

        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);
    }

    /**
     * test #delete.
     * 
     */
    public void testDeleteTx() {
        super.readXlsWriteDb("tasks.xls");
        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);

        int result = this.taskToTasksDao_.delete(taskToTask);
        super.assertEquals("[OK]", 1, result);
    }

    /**
     * test #findTaskToTasksByTaskId.
     * 
     */
    public void testFindTaskToTasksByTaskIdTx() {
        super.readXlsWriteDb("tasks.xls");
        TaskToTask taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9990);
        taskToTask.setDestinationTaskId(9991);
        this.taskToTasksDao_.insert(taskToTask);

        taskToTask = new TaskToTask();
        taskToTask.setSourceTaskId(9991);
        taskToTask.setDestinationTaskId(9992);
        this.taskToTasksDao_.insert(taskToTask);

        TaskToTask[] tasks = this.taskToTasksDao_.findTaskToTasksByTaskId(9991);
        super.assertNotNull(tasks);
        super.assertEquals("[OK]", true, 0 < tasks.length);
        super.assertEquals("[OK]", 2, tasks.length);
    }
}
