package org.seasar.tugboat.gtd.contents.task.dao;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.tugboat.gtd.contents.task.entity.Task;

/**
 * test TasksDao.
 * 
 * @author yosuke
 * 
 */
public class TestTasksDao extends S2DaoTestCase {
    TasksDao taskDao_;
    
    /*
     * (non-Javadoc)
     * 
     * @see junit.framework.TestCase#setUp()
     */
    public void setUp() {
        this.include("dicon/contents/task/taskDao.dicon");
    }
    
    /**
     * test TestTasksDao#getNewTaskId.
     *
     */
    public void testGetNewTaskIdTx() {
        super.readXlsWriteDb("tasks.xls");
        
        Task task = this.taskDao_.getNewTaskId();
        super.assertEquals("[OK]", 10000, task.getId());
    }
    
    /**
     * test TestTasksDao#insert.
     *
     */
    public void testInsertTx() {
        super.readXlsWriteDb("tasks.xls");
        
        Task task = new Task();
        task.setId(10000);
        task.setTitle("Task-10000-title");
        task.setPriorityOrder(0);
        this.taskDao_.insert(task);
        
        task.setId(10001);
        task.setTitle("Task-10001-title");
        task.setDeadline("20070531");
        task.setDeadlineYear(2007);
        task.setDeadlineMonth(5);
        task.setDeadlineDayOfMonth(31);
        this.taskDao_.insert(task);
    }
    
    /**
     * test TestTasksDao#update.
     *
     */
    public void testUpdateTx() {
        super.readXlsWriteDb("tasks.xls");
        
        Task task = new Task();
        task.setId(10000);
        task.setTitle("Task-10000-title");
        task.setShare(0);
        task.setPriorityOrder(0);
        task.setPrivacy(0);
        this.taskDao_.insert(task);
        
        task.setTitle("Task-10000-title-update");
        this.taskDao_.update(task);
        
        task.setDeadline("20070531");
        task.setDeadlineYear(2007);
        task.setDeadlineMonth(5);
        task.setDeadlineDayOfMonth(31);
        this.taskDao_.update(task);
    }
    
    /**
     * test TestTasksDao#updateDeleteFlag.
     *
     */
    public void testUpdateDeleteFlagTx() {
        super.readXlsWriteDb("tasks.xls");
        
        Task task = new Task();
        task.setId(10000);
        task.setTitle("Task-10000-title");
        task.setShare(0);
        task.setPriorityOrder(0);
        task.setPrivacy(0);
        this.taskDao_.insert(task);
        
        this.taskDao_.updateDeleteFlag(task);
        
        task.setDeleteFlag("1");
        this.taskDao_.updateDeleteFlag(task);
    }
    
    /**
     * test #getUpdateTargetByDate.
     *
     */
    public void testGetUpdateTargetByDateTx() {
        super.readXlsWriteDb("tasks.xls");
        
        Task[] tasks = 
            this.taskDao_.getUpdateTargetByDate("20070505");
        
        super.assertNotNull(tasks);
        super.assertEquals("[OK]", true, 0 < tasks.length);
    }
}
