package org.seasar.tugboat.gtd.contents.user.dao;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.tugboat.gtd.contents.common.entity.Role;
import org.seasar.tugboat.gtd.contents.user.entity.User;

public class TestUserRoleDao extends S2TestCase {
    UserRolesDao userRoleDao_;

    protected void setUp() throws Exception {
        this.include("dicon/contents/user/userDao.dicon");
    }

    public void testFindUserRoleByUserIdTx() {
        super.readXlsWriteDb("users.xls");
        {
            Role userRole = userRoleDao_.findUserRoleByUserId(9990);
            assertNotNull(userRole);
            assertEquals(userRole.getId(), 1);
            assertEquals(userRole.getName(), "ADMIN");
        }

        {
            Role userRole = userRoleDao_.findUserRoleByUserId(9995);
            assertNotNull(userRole);
            assertEquals(userRole.getId(), 2);
            assertEquals(userRole.getName(), "USER");
        }

        {
            Role userRole = userRoleDao_.findUserRoleByUserId(9998);
            assertNotNull(userRole);
            assertEquals(userRole.getId(), 3);
            assertEquals(userRole.getName(), "GUEST");
        }

    }
    
    
    public void testAddTx() {
        super.readXlsWriteDb("userRole.xls");
        User user = new User();
        user.setUserId(9999);

        userRoleDao_.add(user, 100);
        assertEquals(userRoleDao_.findUserRoleByUserId(9999).getId(), 100);
    }
    
    public void testUpdateTx() {
        super.readXlsWriteDb("users.xls");
        User user = new User();
        user.setUserId(9990);
        userRoleDao_.update(user, 1);
        assertEquals(1,userRoleDao_.findUserRoleByUserId(9990).getId());
    }

}
