package org.seasar.tugboat.gtd.contents.user.service;

import java.math.BigDecimal;

import org.seasar.dao.unit.S2DaoTestCase;
import org.seasar.extension.dataset.DataTable;
import org.seasar.tugboat.gtd.contents.user.dto.UserDto;
import org.seasar.tugboat.gtd.contents.user.service.UserService;

public class TestUserServiceImpl extends S2DaoTestCase {
    UserService userService;
    
    
    
    protected void setUp() throws Exception {
        System.out.println("before test, init database.");
        this.include("dicon/contents/user/user.dicon"); 
    }

    public void testAddXlsTx() throws Exception {
        super.readXlsWriteDb("users.xls");
        int column_before = readDbByTable("users").getRowSize();
        UserDto modifiedUser = new UserDto();
        modifiedUser.setUserId(9990);
        userService.addFromExcelFile(this.getClass().getResourceAsStream("/userAdmin_import.xls"),modifiedUser);
        int column_after= readDbByTable("users").getRowSize();
        assertEquals(column_after-column_before, 2);
        DataTable tbl = readDbBySql("select modified_user_id from users where login_id = 'test2'","addXls");
        BigDecimal modifiedId = (BigDecimal)tbl.getRow(0).getValue(0);
        assertEquals(modifiedId.intValue(), 9990);
    }
    
    public void testGetUsersTx(){
//        super.readXlsWriteDb("users.xls");        
//        UserDto[] users = userService.getUsers();
//        assertEquals(users.length,11); // please modify
    }
    public void testAddUserTx() {
        super.readXlsWriteDb("users.xls");        
        
        UserDto user = userService.getUserId();
        user.setLoginId("testlogin");
        user.setPassword("testpassword");
        user.setEmail("testEmail@tugboat.com");
        user.setLastName("testLast");
        user.setFirstName("testFirst");
        user.setModifiedUserId(9990);
        user.setRoleId(1);
        System.out.println("##########"+user.getUserId());
        UserDto user2 = userService.addUser(user);
        assertEquals(user.getEmail(), user2.getEmail());
        assertEquals(user.getLoginId(),user2.getLoginId());
        assertEquals(user.getPassword(),user2.getPassword());
        assertEquals(user.getLastName(),user2.getLastName());
        assertEquals(user.getFirstName(),user2.getFirstName());
        
    }
    
    public void testUpdateTx(){
        super.readXlsWriteDb("users.xls");
        UserDto user =userService.getUserById(9990);
        user.setFirstName("testFirstName");
        userService.update(user);
        user = userService.getUserById(9990);
        assertEquals(user.getFirstName(), "testFirstName");
        
    }
    public void testGetUserByIdTx() {
        super.readXlsWriteDb("users.xls");     
        UserDto user = userService.getUserById(9990);
        assertEquals(user.getLoginId(), "test-1");
        assertEquals(user.getUserId(), 9990);
    }
    
    public void testDeleteTx(){
        super.readXlsWriteDb("users.xls");
        UserDto user = userService.getUserById(9990);
        userService.delete(user);
        assertNull(userService.getUserById(9990));
    }
    
    
    public void testFindUserByLoginIdAndPassword() {
        
    }
    
    public void testFindAdminUserByLoginIdAndPassword() {
        
    }
    
    
}
